const tblNuevaCompra = document.querySelector('#tblNuevaCompra tbody');

const serie = document.querySelector('#serie');

const serieDocumento = document.querySelector('#serieDocumento');

const numeroDocumento = document.querySelector('#numeroDocumento');

//const numeroDocumento = document.querySelector('#tipo-vista');





//provedores

const telefonoProveedor = document.querySelector('#telefonoProveedor');

const direccionProveedor = document.querySelector('#proveedorDireccion');

const idProveedor = document.querySelector('#idProveedor');

const errorProveedor = document.querySelector('#errorProveedor');

const errorSerieFactura = document.querySelector('#errorSerieFactura');

const errorNumeroFactura = document.querySelector('#errorNumeroFactura');



document.addEventListener('DOMContentLoaded', function () {

    //autocomplete proveedores

    $("#buscarProveedor").autocomplete({

        source: function (request, response) {

            $.ajax({

                url: base_url + 'proveedor/buscar',

                dataType: "json",

                data: {

                    term: request.term

                },

                success: function (data) {

                    response(data);

                    if (data.length > 0) {

                        errorProveedor.textContent = '';

                    } else {

                        errorProveedor.textContent = 'NO HAY PROVEEDOR CON ESE NOMBRE';

                    }

                }

            });

        },

        minLength: 2,

        select: function (event, ui) {

            telefonoProveedor.value = ui.item.telefono;

            direccionProveedor.innerHTML = ui.item.direccion;

            idProveedor.value = ui.item.id;

            serieDocumento.focus();

        }

    });



    //cargar datos

    mostrarProducto();



    //completar compra

    btnAccion.addEventListener('click', function () {

        let filas = document.querySelectorAll('#tblNuevaCompra tr').length;

        if (filas < 2) {

            alertaPersonalizada('warning', 'CARRITO VACIO');

            return;

        } else if (idProveedor.value == '' && telefonoProveedor.value == '') {

            alertaPersonalizada('warning', 'EL PROVEEDOR ES REQUERIDO');

            return;

        } else if (serie.value == '') {

            alertaPersonalizada('warning', 'LA SERIE ES REQUERIDO');

            return;

        } else if (serieDocumento.value == '') {

            alertaPersonalizada('warning', 'LA SERIE DE LA FACTURA ES REQUERIDO');

            return;

        } else if (numeroDocumento.value == '') {

            alertaPersonalizada('warning', 'EL NUMERO DE LA FACTURA ES REQUERIDO');

            return;        

        } else {

        	//alert("ACCESO RESTRINGIDO SU USUARIO NO CUENTA CON PERMISO");

            const url = base_url + 'compras/registrarCompra';

            //hacer una instancia del objeto XMLHttpRequest 

            const http = new XMLHttpRequest();

            //Abrir una Conexion - POST - GET

            http.open('POST', url, true);

            //Enviar Datos

            //console.log(serieDocumento.value);

            //console.log(numeroDocumento.value);

            http.send(JSON.stringify({

                productos: listaCarrito,

                idProveedor: idProveedor.value,

                serie: serie.value,

                serieDocumento: serieDocumento.value,

                numeroDocumento: numeroDocumento.value

            }));

            //serieDocumento: serieDocumento.value, numeroDocumento: numeroDocumento.value

            //verificar estados

            http.onreadystatechange = function () {

                if (this.readyState == 4 && this.status == 200) {

                    //sconsole.log(this.responseText);

                    const res = JSON.parse(this.responseText);

                    //console.log(this.responseText);

                    alertaPersonalizada(res.type, res.msg);

                    if (res.type == 'success') {

                        localStorage.removeItem(nombreKey);

                        setTimeout(() => {

                            Swal.fire({

                                title: 'Desea Generar Reporte?',

                                showDenyButton: true,

                                showCancelButton: true,

                                //confirmButtonText: 'Ticked',

                                denyButtonText: `Factura`,

                            }).then((result) => {

                                // Read more about isConfirmed, isDenied below

                                //if (result.isConfirmed) {

                                 //   const ruta = base_url + 'compras/reporte/ticked/' + res.idCompra;

                                 //   window.open(ruta, '_blank');

                                //} else 

                                if (result.isDenied) {

                                    const ruta = base_url + 'compras/reporte/factura/' + res.idCompra;

                                    window.open(ruta, '_blank');

                                }

                                window.location.reload();//activar

                            })



                        }, 2000);

                    }

                }

            }

        }



    })



    //mostrar historial

    //cargar datos con el plugin datatables

    tblHistorial = $('#tblHistorial').DataTable({

        ajax: {

            url: base_url + 'compras/listar',

            dataSrc: ''

        },

        columns: [

            { data: 'fecha' },

            { data: 'hora' },

            { data: 'total' },

            { data: 'nombre' },

            { data: 'serie' },

            { data: 'acciones' },

        ],

        language: {

            url: base_url + 'assets/js/espanol.json'

        },

        dom,

        buttons,

        responsive: true,

        order: [[0, 'desc']],

    });



})



//cargar productos

function mostrarProducto() {//chacho

    if (localStorage.getItem(nombreKey) != null) {

        const url = base_url + 'productos/mostrarDatos';//http://posv1.dulcemaravillasa.com/

        //hacer una instancia del objeto XMLHttpRequest 

        const http = new XMLHttpRequest();

        //Send the proper header information along with the request

		//http.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');

		http.withCredentials = false;

        //Abrir una Conexion - POST - GET

        http.open('POST', url, true);

        //Enviar Datos

        http.send(JSON.stringify(listaCarrito));

        //verificar estados

        http.onreadystatechange = function () {

            if (this.readyState == 4 && this.status == 200) {

                const res = JSON.parse(this.responseText);

                let html = '';

                if (res.productos.length > 0) {

                    res.productos.forEach(producto => {

                    	let colorFondo = "";

                        if(producto.tipo == 1){//padre

                        	//colorFondo = "background-color: #77dd77;font-weight: bolder;";

                        	colorFondo = "background-color: #000035;font-weight: bolder;color: #ffffff !important;";

                        }else if(producto.tipo == 2){//hijo

                        	//colorFondo = "background-color: #ffca99;font-weight: bolder;";

                        	colorFondo = "background-color: #607ec9;font-weight: bolder;";

                        	

                        }

                        

                        html += `<tr style="${colorFondo}">

                        	<td>${producto.codigo}</td>

                            <td>${producto.nombre}  [${producto.id}]</td>

                            <td>Q${producto.precio_compra}</td>

                            <td width="100">

                            <input type="number" class="form-control inputCantidad" data-id="${producto.id}" value="${producto.cantidad}" placeholder="Cantidad">

                            </td>

                            <td>Q${producto.subTotalCompra}</td>

                            <td><button class="btn btn-danger btnEliminar" data-id="${producto.id}" type="button"><i class="fas fa-trash"></i></button></td>

                        </tr>`;

                    });

                    tblNuevaCompra.innerHTML = html;

                    totalPagar.value = res.totalCompra;

                    btnEliminarProducto();

                    agregarCantidad();

                } else {

                    tblNuevaCompra.innerHTML = '';

                }

            }

        }

    } else {

        tblNuevaCompra.innerHTML = `<tr>

            <td colspan="4" class="text-center">CARRITO VACIO</td>

        </tr>`;

    }

}



function verReporte(idCompra) {

    Swal.fire({

        title: 'Desea Generar Reporte?',

        showDenyButton: true,

        showCancelButton: true,

        //confirmButtonText: 'Ticked',

        denyButtonText: `Factura`,

    }).then((result) => {

        /* Read more about isConfirmed, isDenied below */

        /*if (result.isConfirmed) {

            const ruta = base_url + 'compras/reporte/ticked/' + idCompra;

            window.open(ruta, '_blank');

        } else */if (result.isDenied) {

            const ruta = base_url + 'compras/reporte/factura/' + idCompra;

            window.open(ruta, '_blank');

        }

    })

}



function anularCompra(idCompra) {

    Swal.fire({

        title: 'Esta seguro de anular la compra?',

        text: "El stock de los productos cambiarán!",

        icon: 'warning',

        showCancelButton: true,

        confirmButtonColor: '#3085d6',

        cancelButtonColor: '#d33',

        confirmButtonText: 'Si, Anular!'

    }).then((result) => {

        if (result.isConfirmed) {

            const url = base_url + 'compras/anular/' + idCompra;

            //hacer una instancia del objeto XMLHttpRequest 

            const http = new XMLHttpRequest();

            //Abrir una Conexion - POST - GET

            http.open('GET', url, true);

            //Enviar Datos

            http.send();

            //verificar estados

            http.onreadystatechange = function () {

                if (this.readyState == 4 && this.status == 200) {

                    const res = JSON.parse(this.responseText);

                    alertaPersonalizada(res.type, res.msg);

                    if (res.type == 'success') {

                        tblHistorial.ajax.reload();

                    }

                }

            }

        }

    })

}