const tblNuevaVenta = document.querySelector('#tblNuevaVenta tbody');
const idCliente = document.querySelector('#idCliente');

const telefonoCliente = document.querySelector('#telefonoCliente');

const direccionCliente = document.querySelector('#direccionCliente');

const errorCliente = document.querySelector('#errorCliente');



const descuento = document.querySelector('#descuento');

const metodo = document.querySelector('#metodo');

const impresion_directa = false;//document.querySelector('#impresion_directa');

document.addEventListener('DOMContentLoaded', function () {

    //cargar productos de localStorage

    mostrarProducto();



    //autocomplete clientes

    $("#buscarCliente").autocomplete({

        source: function (request, response) {

            $.ajax({

                url: base_url + 'clientes/buscar',

                dataType: "json",

                data: {

                    term: request.term

                },

                success: function (data) {

                    response(data);

                    if (data.length > 0) {

                        errorCliente.textContent = '';

                    } else {

                        errorCliente.textContent = 'NO HAY CLIENTE CON ESE NOMBRE';

                    }

                }

            });

        },

        minLength: 2,

        select: function (event, ui) {

            telefonoCliente.value = ui.item.telefono;

            direccionCliente.innerHTML = ui.item.direccion;

            idCliente.value = ui.item.id;

        }

    });





    //completar venta

    btnAccion.addEventListener('click', function () {

        let filas = document.querySelectorAll('#tblNuevaVenta tr').length;

        if (filas < 2) {

            alertaPersonalizada('warning', 'CARRITO VACIO');

            return;

        } else if (metodo.value == '') {

            alertaPersonalizada('warning', 'EL METODO ES REQUERIDO');

            return;

        } else {

            console.log("Registros a Grabar: ");

            console.log(listaCarrito);

            //console.log(idCliente.value);

            const url = base_url + 'pedidos/registrarVenta';

            //hacer una instancia del objeto XMLHttpRequest 

            const http = new XMLHttpRequest();

            //Abrir una Conexion - POST - GET

            http.open('POST', url, true);

            //Enviar Datos

            http.send(JSON.stringify({

                productos: listaCarrito,

                idCliente: idCliente.value,

                metodo: metodo.value,

                descuento: descuento.value,

                impresion: false///impresion_directa.checked

            }));

            //verificar estados

            http.onreadystatechange = function () {

                if (this.readyState == 4 && this.status == 200) {

                    const res = JSON.parse(this.responseText);

                    console.log(this.responseText);

                    alertaPersonalizada(res.type, res.msg);

                    if (res.type == 'success') {

                        localStorage.removeItem(nombreKey);

                        setTimeout(() => {

                            Swal.fire({

                                title: 'Desea Generar Reporte?',

                                showDenyButton: true,

                                showCancelButton: true,

                                //confirmButtonText: 'Ticked',

                                denyButtonText: `Nota de Venta`,

                            }).then((result) => {

                                // Read more about isConfirmed, isDenied below

                                //if (result.isConfirmed) {

                                  //  const ruta = base_url + 'pedidos/reporte/ticked/' + res.idVenta;

                                   // window.open(ruta, '_blank');

                                //} else 

                                if (result.isDenied) {

                                    const ruta = base_url + 'pedidos/reporte/factura/' + res.idVenta;

                                    window.open(ruta, '_blank');

                                }

                                window.location.reload();

                            })



                        }, 2000);

                    }

                }

            }

        }

    })



    //cargar datos con el plugin datatables

    tblHistorial = $('#tblHistorial').DataTable({

        ajax: {

            url: base_url + 'pedidos/listar',

            dataSrc: ''

        },

        columns: [

            { data: 'fecha' },

            { data: 'hora' },

            { data: 'total' },

            { data: 'nombre' },

            { data: 'serie' },

            { data: 'metodo' },

            { data: 'acciones' }

        ],

        language: {

            url: base_url + 'assets/js/espanol.json'

        },

        dom,

        buttons,

        responsive: true,

        order: [[4, 'desc']],

    });



})



//cargar productos

function mostrarProducto() {

    if (localStorage.getItem(nombreKey) != null) {

        const url = base_url + 'productos/mostrarDatos';

        //hacer una instancia del objeto XMLHttpRequest 

        const http = new XMLHttpRequest();

        //Abrir una Conexion - POST - GET

        http.open('POST', url, true);

        //Enviar Datos

        http.send(JSON.stringify(listaCarrito));

        let totalVenta = 0;

        //verificar estados

        http.onreadystatechange = function () {

            if (this.readyState == 4 && this.status == 200) {

                const res = JSON.parse(this.responseText);

                console.log("RESPUESTA DATA location: ");

                //console.log(res);

                listaCarrito = [];

                if (localStorage.getItem("posVenta") != null) {

                    listaCarrito = JSON.parse(localStorage.getItem("posVenta"));

                    //listaCarrito.reverse();

                }

                //console.log(listaCarrito);

                //console.log(listaCarrito.reverse());



                let html = '';

                if (res.productos.length > 0) {

                    res.productos.forEach(producto => {

                        /*if(listaCarrito.length > 0){

                            listaCarrito.forEach(productos =>{

                                console.log(productos.id,productos.precio_venta);

                                console.log(producto.precio_venta);

                            });

                        }*/

                        //selected ${producto.id}

                        let colorFondo = "";

                        if(producto.tipo == 1){//padre

                        	//colorFondo = "background-color: #77dd77;font-weight: bolder;";

                        	colorFondo = "background-color: #000035;font-weight: bolder;color: #ffffff !important;";

                        }else if(producto.tipo == 2){//hijo

                        	//colorFondo = "background-color: #ffca99;font-weight: bolder;";

                        	colorFondo = "background-color: #607ec9;font-weight: bolder;";

                        	

                        }

                        html += `<tr style="${colorFondo}">

                            <td>${producto.codigo}</td><!--- ${producto.tipo}- ${producto.id_padre}-->

                            <td>${producto.nombre}  [${producto.id}]</td>

                            <!--<td>padre/hijo:${producto.tipo}<br>idPadre:${producto.id_padre}</td>-->

                            <td>${producto.stock}</td>

                            <td>${producto.cantidad2}</td>

                            <td>`;

                            

                            let seleccionado ="";    

                            let subTotalVenta = 0;

                            	/*html += `<fieldset>

								    <legend>Seleccione un Precio</legend>

								

								    <div>

								      <input type="radio" id="publico" name="listPrecio" value="1" checked>

								      <label for="huey">Q99 Público</label>

								    </div>

								

								    <div>

								      <input type="radio" id="minorista" name="listPrecio" value="2">

								      <label for="dewey">Q95 Minorista</label>

								    </div>

								

								    <div>

								      <input type="radio" id="mayorista" name="listPrecio" value="3">

								      <label for="louie">Q85 Mayorista</label>

								    </div>

								 </fieldset>`;*/

								listaCarrito.forEach(productoStorage => {

									if(producto.id == productoStorage.id){

										subTotalVenta = productoStorage.cantidad*productoStorage.precioVenta;

                                        totalVenta = subTotalVenta+totalVenta;

										//html += `${producto.id} ${productoStorage.id} ${subTotalVenta} ${totalVenta}`;

										//html += `id: ${productoStorage.id} storage: ${productoStorage.precioVenta} producto: ${producto.precio_venta}`;

									    

									    if(producto.precio_venta == productoStorage.precioVenta){

                                            html += `<div>

										      <input type="radio" id="publico${productoStorage.id}" dataprecio-id="${producto.id}" precio-pro="${producto.precio_venta}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="1" checked>

										      <label for="publico">Q${producto.precio_venta}--Público</label>

										    </div>`;

                                        }else{

                                            html += `<div>

										      <input type="radio" id="publico${productoStorage.id}" dataprecio-id="${producto.id}" precio-pro="${producto.precio_venta}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="1">

										      <label for="publico">Q${producto.precio_venta}--Público</label>

										    </div>`;

                                        }

                                        if(producto.precio_venta2 == productoStorage.precioVenta){

                                            html += `<div>

										      <input type="radio" id="minorista${productoStorage.id}" dataprecio-id="${producto.id}" precio-pro="${producto.precio_venta2}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="2" checked>

										      <label for="minorista">Q${producto.precio_venta2}--Minorista</label>

										    </div>`;

                                        }else{

                                            html += `<div>

										      <input type="radio" id="minorista${productoStorage.id}" dataprecio-id="${producto.id}"  precio-pro="${producto.precio_venta2}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="2">

										      <label for="minorista">Q${producto.precio_venta2}--Minorista</label>

										    </div>`;

                                        }

                                        if(producto.precio_venta3 == productoStorage.precioVenta){

                                            html += `<div>

										      <input type="radio" id="mayorista${productoStorage.id}" dataprecio-id="${producto.id}"  precio-pro="${producto.precio_venta3}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="3" checked>

										      <label for="mayorista">Q${producto.precio_venta3}--Mayorista</label>

										    </div>`;

                                        }else{

                                            html += `<div>

										      <input type="radio" id="mayorista${productoStorage.id}" dataprecio-id="${producto.id}"  precio-pro="${producto.precio_venta3}" class="inputPrecioVenta" name="uno${productoStorage.id}" value="3">

										      <label for="mayorista">Q${producto.precio_venta3}--Mayorista</label>

										    </div>`;

                                        }

									}

								});	

								 

                                /*html += `<select dataprecio-id="${producto.id}" class="form-control inputPrecioVenta">`;

                                        

                                        listaCarrito.forEach(productoStorage => {

                                        	//${producto.id} ${productoStorage.id}

                                            if(producto.id == productoStorage.id){

                                                //subTotalVenta = productoStorage.cantidad*productoStorage.precioVenta;

                                                //totalVenta = subTotalVenta+totalVenta;

                                                if(producto.precio_venta == productoStorage.precioVenta){

                                                    html += `<option value="${producto.precio_venta}" dataprecioventa-id="${producto.precio_venta}" selected>Público--Q${producto.precio_venta}</option>`;

                                                }else{

                                                    html += `<option value="${producto.precio_venta}" dataprecioventa-id="${producto.precio_venta}">Público--Q${producto.precio_venta}</option>`;

                                                }

                                                if(producto.precio_venta2 == productoStorage.precioVenta){

                                                    html += `<option value="${producto.precio_venta2}" dataprecioventa-id="${producto.precio_venta2}" selected>Minorista--Q${producto.precio_venta2}</option>`;

                                                }else{

                                                    html += `<option value="${producto.precio_venta2}" dataprecioventa-id="${producto.precio_venta2}">Minorista--Q${producto.precio_venta2}</option>`;

                                                }

                                                if(producto.precio_venta3 == productoStorage.precioVenta){

                                                    html += `<option value="${producto.precio_venta3}" dataprecioventa-id="${producto.precio_venta3}" selected>Mayorista--Q${producto.precio_venta3}</option>`;

                                                }else{

                                                    html += `<option value="${producto.precio_venta3}" dataprecioventa-id="${producto.precio_venta3}">Mayorista--Q${producto.precio_venta3}</option>`;

                                                }

                                            }

                                        });



                                 html += `</select>`;*/

                                 

                        html += `<!--<input type="number" class="form-control inputPrecioVenta2" dataprecio2-id="${producto.id}" value="${producto.precio_venta}" disabled>-->

                            </td>

                            <td width="100">

                            <input type="number" class="form-control inputCantidad" data-id="${producto.id}" value="${producto.cantidad}">

                            </td>

                            <!--<td>${producto.subTotalVenta}</td>-->

                            <td>Q${subTotalVenta.toFixed(2)}</td>

                            <td><button class="btn btn-danger btnEliminar" data-id="${producto.id}" type="button"><i class="fas fa-trash"></i></button></td>

                        </tr>`;//number_format($totalVenta, 2);

                    });

                    tblNuevaVenta.innerHTML = html;

                    //totalPagar.value = res.totalVenta;

                    console.log(totalVenta);

                    totalPagar.value = totalVenta;

                    btnEliminarProducto();

                    agregarCantidad();

                    agregarPrecioVenta();

                    agregarPrecioVentaRadio();

                    cambiarTipoPrecio();

                } else {

                    tblNuevaVenta.innerHTML = '';

                }

            }

        }

    } else {

        tblNuevaVenta.innerHTML = `<tr>

            <td colspan="4" class="text-center">CARRITO VACIO</td>

        </tr>`;

    }

}



function verReporte(idVenta) {

    Swal.fire({

        title: 'Desea Generar Reporte?',

        showDenyButton: true,

        showCancelButton: true,

        //confirmButtonText: 'Ticked',

        denyButtonText: `Nota de Venta`,

    }).then((result) => {

        /* Read more about isConfirmed, isDenied below */

        if (result.isConfirmed) {

            const ruta = base_url + 'pedidos/reporte/ticked/' + idVenta;

            //window.open(ruta, '_blank');

        } else if (result.isDenied) {

            const ruta = base_url + 'pedidos/reporte/factura/' + idVenta;

            window.open(ruta, '_blank');

        }

    })

}



function anularVenta(idVenta) {

    Swal.fire({

        title: 'Esta seguro de anular la venta?',

        text: "El stock de los productos cambiarán!",

        icon: 'warning',

        showCancelButton: true,

        confirmButtonColor: '#3085d6',

        cancelButtonColor: '#d33',

        confirmButtonText: 'Si, Anular!'

    }).then((result) => {

        if (result.isConfirmed) {

            const url = base_url + 'pedidos/anular/' + idVenta;

            //hacer una instancia del objeto XMLHttpRequest 

            const http = new XMLHttpRequest();

            //Abrir una Conexion - POST - GET

            http.open('GET', url, true);

            //Enviar Datos

            http.send();

            //verificar estados

            http.onreadystatechange = function () {

                if (this.readyState == 4 && this.status == 200) {

                    const res = JSON.parse(this.responseText);

                    alertaPersonalizada(res.type, res.msg);

                    if (res.type == 'success') {

                        tblHistorial.ajax.reload();

                    }

                }

            }

        }

    })

}



function alertCambioPrecio(idVenta) {

    Swal.fire({

        title: 'Esta seguro de anular la venta?',

        text: "El stock de los productos cambiarán!",

        icon: 'warning',

        showCancelButton: true,

        confirmButtonColor: '#3085d6',

        cancelButtonColor: '#d33',

        confirmButtonText: 'Si, Anular!'

    }).then((result) => {

        if (result.isConfirmed) {

            /*const url = base_url + 'pedidos/anular/' + idVenta;

            //hacer una instancia del objeto XMLHttpRequest 

            const http = new XMLHttpRequest();

            //Abrir una Conexion - POST - GET

            http.open('GET', url, true);

            //Enviar Datos

            http.send();

            //verificar estados

            http.onreadystatechange = function () {

                if (this.readyState == 4 && this.status == 200) {

                    const res = JSON.parse(this.responseText);

                    alertaPersonalizada(res.type, res.msg);

                    if (res.type == 'success') {

                        tblHistorial.ajax.reload();

                    }

                }

            }*/

        }

    })

}