<?php



require 'vendor/autoload.php';







use Dompdf\Dompdf;
use Mockery\Undefined;
use PhpOffice\PhpSpreadsheet\Spreadsheet;



use PhpOffice\PhpSpreadsheet\IOFactory;



use PhpOffice\PhpSpreadsheet\Style\Color;



use PhpOffice\PhpSpreadsheet\Style\Fill;







class Productos extends Controller



{



    public function __construct()



    {



        parent::__construct();



        session_start();



        if (empty($_SESSION['id_usuario'])) {



            header('Location: ' . BASE_URL);



            exit;



        }



    }



    public function index()



    {



        $data['title'] = 'Productos';



        $data['script'] = 'productos.js';



        $data['medidas'] = $this->model->getDatos('medidas');



        $data['categorias'] = $this->model->getDatos('categorias');



        $this->views->getView('productos', 'index', $data);



    }



    public function listar()



    {



        $data = $this->model->getProductos(1);



        for ($i = 0; $i < count($data); $i++) {



            $foto = ($data[$i]['foto'] == null) ? 'assets/images/productos/default.png' :  $data[$i]['foto'];



            $data[$i]['imagen'] = '<img class="img-thumbnail" src="' . $foto . '" width="50">';



            $data[$i]['acciones'] = '<div class="btblpc">



            <button class="btn btn-danger" type="button" onclick="eliminarProducto(' . $data[$i]['id'] . ')"><i class="fas fa-trash"></i></button>



            <button class="btn btn-info" type="button" onclick="editarProducto(' . $data[$i]['id'] . ')"><i class="fas fa-edit"></i></button>



            </div>';



        }



        echo json_encode($data, JSON_UNESCAPED_UNICODE);



        die();



    }



    public function registrar()



    {



        if (isset($_POST['codigo']) && isset($_POST['nombre'])) {



            $id = strClean($_POST['id']);



            $codigo = strClean($_POST['codigo']);



            $nombre = strClean($_POST['nombre']);



            $precio_compra = strClean($_POST['precio_compra']);



            $precio_venta = strClean($_POST['precio_venta']);



            $precio_venta2 = strClean($_POST['precio_venta2']);



            $precio_venta3 = strClean($_POST['precio_venta3']);



            $id_medida = strClean($_POST['id_medida']);



            $id_categoria = strClean($_POST['id_categoria']);



            $fotoActual = strClean($_POST['foto_actual']);



            



            $tipo = strClean($_POST['tipo']);



            //$salida = "t";//strClean($_POST['salida']);



            $unidad_venta = strClean($_POST['unidad_venta']);



            $factor = strClean($_POST['factor']);



            $fechaVencimiento = strClean($_POST['fecha_vencimiento']);



            $idPadre = $_POST['id_padre'];





            $foto = $_FILES['foto'];



            $name = $foto['name'];



            $tmp = $foto['tmp_name'];







            $destino = null;



            if (!empty($name)) {



                $fecha = date('YmdHis');



                $destino = 'assets/images/productos/' . $fecha . '.jpg';



            } else if (!empty($fotoActual) && empty($name)) {



                $destino = $fotoActual;



            }



            if (empty($codigo)) {



                $res = array('msg' => 'EL CODIGO ES REQUERIDO', 'type' => 'warning');



            } else if (empty($nombre)) {



                $res = array('msg' => 'EL NOMBRE ES REQUERIDO', 'type' => 'warning');



            } else if (empty($precio_compra)) {



                $res = array('msg' => 'EL PRECIO COMPRA ES REQUERIDO', 'type' => 'warning');



            } else if (empty($precio_venta)) {



                $res = array('msg' => 'EL PRECIO VENTA 1 ES REQUERIDO', 'type' => 'warning');



            } else if (empty($precio_venta2)) {



                $res = array('msg' => 'EL PRECIO VENTA 2 ES REQUERIDO', 'type' => 'warning');



            } else if (empty($precio_venta3)) {



                $res = array('msg' => 'EL PRECIO VENTA 3 ES REQUERIDO', 'type' => 'warning');        



            } else if (empty($id_medida)) {



                $res = array('msg' => 'LA MEDIDA ES REQUERIDO', 'type' => 'warning');



            } else if (empty($id_categoria)) {



                $res = array('msg' => 'LA CATEGORIA ES REQUERIDO', 'type' => 'warning');



            } else if (empty($tipo)) {    



                $res = array('msg' => 'EL TIPO ES REQUERIDO', 'type' => 'warning');



            } else if (empty($unidad_venta)) {  



                $res = array('msg' => 'LA UNIDAD DE VENTA ES REQUERIDO', 'type' => 'warning');



            } else if (empty($fechaVencimiento)) {  



                $res = array('msg' => 'LA FECHA DE VENCIMIENTO ES REQUERIDO', 'type' => 'warning');



            } else if ($idPadre < 0) {



                $res = array('msg' => 'INGRESE EL CÓDIGO DEL PADRE SI ES UN PRODUCTO HIJO, SI ES UN PRODUCTO PADRE DEJE CON VALOR DE CERO', 'type' => 'warning');



            } else {



                if ($id == '') {



                    $verificar = $this->model->getValidar('codigo', $codigo, 'registrar', 0);



                    if (empty($verificar)) {



                        $data = $this->model->registrar(



                            $codigo,



                            $nombre,



                            $precio_compra,



                            $precio_venta,



                            $precio_venta2,



                            $precio_venta3,



                            $id_medida,



                            $id_categoria,



                            $destino,



                            $tipo,



                            $unidad_venta,



                            $factor,



                            $fechaVencimiento,



                            $idPadre



                        );



                        //$tipo,$salida,$unidad_venta,$factor



                        if ($data > 0) {



                            if (!empty($name)) {



                                move_uploaded_file($tmp, $destino);



                            }



                            $res = array('msg' => 'PRODUCTO REGISTRADO', 'type' => 'success');



                        } else {



                            $res = array('msg' => 'ERROR AL REGISTRAR', 'type' => 'error');



                        }



                    } else {



                        $res = array('msg' => 'LA CODIGO DEBE SER ÚNICO', 'type' => 'warning');



                    }



                } else {

                    

                    $verificar = $this->model->getValidar('codigo', $codigo, 'actualizar', $id);

                    

                    if (empty($verificar)) {

                        //var_dump("llego 265:".$idPadre." verificar:".$verificar." id:".$id);

                        $data = $this->model->actualizar(

                            $codigo,

                            $nombre,

                            $precio_compra,

                            $precio_venta,

                            $precio_venta2,

                            $precio_venta3,

                            $id_medida,

                            $id_categoria,

                            $destino,

                            $unidad_venta,

                            $factor,

                            $fechaVencimiento,

                            $idPadre,

                            $id

                        );



						//$tipo,$idPadre



                        //$tipo,$salida,$unidad_venta,$factor



                        if ($data > 0) {



                            if (!empty($name)) {



                                move_uploaded_file($tmp, $destino);



                            }



                            $res = array('msg' => 'PRODUCTO MODIFICADO', 'type' => 'success');



                        } else {



                            $res = array('msg' => 'ERROR AL MODIFICAR', 'type' => 'error');



                        }



                    } else {



                        $res = array('msg' => 'EL CODIGO DEBE SER ÚNICO', 'type' => 'warning');



                    }



                }



            }



        } else {



            $res = array('msg' => 'ERROR DESCONOCIDO', 'type' => 'error');



        }



        echo json_encode($res);



        die();



    }







    public function eliminar($idProducto)



    {



        if (isset($_GET) && is_numeric($idProducto)) {



            //$data = $this->model->eliminar(0, $idProducto);



			$data = $this->model->eliminar($idProducto);



            if ($data == 1) {



                $res = array('msg' => 'PRODUCTO DADO DE BAJA', 'type' => 'success');



            } else {



                $res = array('msg' => 'ERROR AL ELIMINAR', 'type' => 'error');



            }



        } else {



            $res = array('msg' => 'ERROR DESCONOCIDO', 'type' => 'error');



        }



        echo json_encode($res);



        die();



    }







    public function editar($idProducto)



    {



        $data = $this->model->editar($idProducto);



        echo json_encode($data, JSON_UNESCAPED_UNICODE);



        die();



    }







    public function inactivos()



    {



        $data['title'] = 'Productos Inactivos';



        $data['script'] = 'productos-inactivos.js';



        $this->views->getView('productos', 'inactivos', $data);



    }







    public function listarInactivos()



    {



        $data = $this->model->getProductos(0);



        for ($i = 0; $i < count($data); $i++) {



            $data[$i]['imagen'] = '<img class="img-thumbnail" src="' . $data[$i]['foto'] . '" width="100">';



            $data[$i]['acciones'] = '<div>



            <button class="btn btn-danger" type="button" onclick="restaurarProducto(' . $data[$i]['id'] . ')"><i class="fas fa-check-circle"></i></button>



            </div>';



        }



        echo json_encode($data, JSON_UNESCAPED_UNICODE);



        die();



    }







    public function restaurar($idProducto)



    {



        if (isset($_GET) && is_numeric($idProducto)) {



            $data = $this->model->eliminar(1, $idProducto);



            if ($data == 1) {



                $res = array('msg' => 'PRODUCTO RESTAURADO', 'type' => 'success');



            } else {



                $res = array('msg' => 'ERROR AL RESTAURAR', 'type' => 'error');



            }



        } else {



            $res = array('msg' => 'ERROR DESCONOCIDO', 'type' => 'error');



        }



        echo json_encode($res);



        die();



    }







    //buscar Productos por codigo



    public function buscarPorCodigo($valor)



    {

    	$dato = explode("|", $valor);
        //echo "a: ".$dato[0]." b:".$dato[1];
        //var_dump($dato);
        //echo "R: ".$dato[1];
    	//,$pantalla
        //echo "Resultado: ".$dato[1];
        $array = array('estado' => false, 'datos' => '');
        
		//$data = $this->model->buscarPorCodigo($valor);
        if($dato[1] == "na"){// || $dato[1] == null || $dato[1] == 'Undefined'
        //if($dato[1] == 'c' || $dato[1] == 'v' || $dato[1] == 'p'){
            $data = $this->model->buscarPorCodigoKardex($dato[0]);
        }else{
            if($dato[1] == 'c'){
                $data = $this->model->buscarPorCodigo($dato[0]);
            }else if($dato[1] == 'v' || $dato[1] == 'p'){
                $data = $this->model->buscarPorCodigoVenta($dato[0]);
            }
        }

        /*if($dato[1] == 'c'){
            $data = $this->model->buscarPorCodigo($dato[0]);
        }else if($dato[1] == 'v' || $dato[1] == 'p'){
            $data = $this->model->buscarPorCodigoVenta($dato[0]);
        }*/

        

        if (!empty($data)) {

            $array['estado'] = true;

            $array['datos'] = $data;

        }

        echo json_encode($array, JSON_UNESCAPED_UNICODE);

        die();

    }



    //buscar Productos Hijo por codigo

    public function buscarPorCodigoHijo($valor)

    {



        $array = array('estado' => false, 'datos' => '');

        $data = $this->model->buscarPorCodigoHijo($valor);

        if (!empty($data)) {

            $array['estado'] = true;

            $array['datos'] = $data;

        }

        echo json_encode($array, JSON_UNESCAPED_UNICODE);

        die();

    }



    //buscar Productos por nombre



    public function buscarPorNombre()

    {
        //echo '<script>alert("compra");</script>';
        $array = array();

        $valor = $_GET['term'];

        $tipoBusqueda = $_GET['tBusqueda'];

		$pantalla = $_GET['pantalla'];//identificar si es compra o venta

        /*echo "pantalla: ".$pantalla; 

        echo "\ntipoBusqueda: ".$tipoBusqueda;*/



        if($tipoBusqueda == 1){//compras

            $data = $this->model->buscarPorNombre($valor);

            foreach ($data as $row) {

                $result['id'] = $row['id'];

                $result['label'] = strtoupper($row['descripcion']).'['.$row['codigo'].']'.'_____________EXISTENCIAS:'.bcdiv($row['stock'],'1',0);

                $result['stock'] = $row['cantidad'];

                $result['precio_venta'] = $row['precio_venta'];

                $result['precio_venta2'] = $row['precio_venta2'];

                $result['precio_venta3'] = $row['precio_venta3'];

                //'['.$row['codigo'].']_'. .$row['precio_venta'].$row['precio_venta2'].$row['precio_venta3'];

                array_push($array, $result);

            }

            echo json_encode($array, JSON_UNESCAPED_UNICODE);

            die();

        }else if($tipoBusqueda == 2){//ventas

            $data = $this->model->buscarPorNombreProVenta($valor);

            $existencia = 0;

            foreach ($data as $row) {

                $result['id'] = $row['id'];

                $result['stock'] = $row['stock'];//'<strong>'.

                $result['label'] = strtoupper($row['descripcion']).'['.$row['codigo'].']'.'_____________EXISTENCIAS:'.bcdiv($row['stock'],'1',0);

                ///$result['precio_compra'] = $row['precio_compra'];

                $result['precio_venta'] = $row['precio_venta'];

                $result['precio_venta2'] = $row['precio_venta2'];

                $result['precio_venta3'] = $row['precio_venta3'];

                $result['tipo'] = $row['tipo'];

                $result['idPadre'] = $row['id_padre'];

                $result['etiqueta'] = $row['etiqueta'];

                //'['.$row['codigo'].']_'. .$row['precio_venta'].$row['precio_venta2'].$row['precio_venta3'];

                array_push($array, $result);

            }

            echo json_encode($array, JSON_UNESCAPED_UNICODE);

            die();

        }    



    }







    //buscar Productos por nombre para la venta



    public function buscarPorNombreProVenta()

    {

        $array = array();

        $valor = $_GET['term'];

        $pantalla = $_GET['pantalla'];



        $data = $this->model->buscarPorNombreProVenta($valor);

        foreach ($data as $row) {

            $result['id'] = $row['id'];

            $result['label'] = strtoupper($row['descripcion']).'['.$row['codigo'].']'.'_____________EXISTENCIAS:'.$row['cantidad'];

            $result['stock'] = $row['cantidad'];

            $result['precio_venta'] = $row['precio_venta'];

            $result['precio_venta2'] = $row['precio_venta2'];

            $result['precio_venta3'] = $row['precio_venta3'];

            //'['.$row['codigo'].']_'. .$row['precio_venta'].$row['precio_venta2'].$row['precio_venta3'];

            array_push($array, $result);

        }

        echo json_encode($array, JSON_UNESCAPED_UNICODE);

        die();

    }







    //mostrar productos desde localStorage



    public function mostrarDatos()



    {



        $json = file_get_contents('php://input');



        $datos = json_decode($json, true);



        $array['productos'] = array();



        $totalCompra = 0;



        $totalVenta = 0;



        $subTotalVenta = 0;



		//var_dump($datos);



        //listaCarrito = [];



        //if (localStorage.getItem("posVenta") != null) {



            //listaCarrito = JSON.parse(localStorage.getItem("posVenta"));



        //}



        //listaCarrito.forEach(productoStorage => {});



        if (!empty($datos)) {



        		//$xy = 1;



            foreach ($datos as $producto) {



                $result = $this->model->editar($producto['id']);



				//$data['item'] = $xy;



                $data['id'] = $result['id'];



                $data['codigo'] = $result['codigo'];



                $data['nombre'] = $result['descripcion'];



                $data['precio_compra'] = $result['precio_compra'];



                $data['precio_venta'] = $result['precio_venta'];



                $data['precio_venta2'] = $result['precio_venta2'];



                $data['precio_venta3'] = $result['precio_venta3'];



                $data['tipo'] = $result['tipo'];



                $data['id_padre'] = $result['id_padre'];



                $data['cantidad'] = $producto['cantidad'];



                $data['stock'] = $result['cantidad'];



                $data['cantidad2'] = $result['cantidad2'];



                $subTotalCompra = $result['precio_compra'] * $producto['cantidad'];



                //$subTotalVenta = $result['precio_venta'] * $producto['cantidad'];



                $subTotalVenta = $result['precio_venta'] * $producto['cantidad'];



                $data['subTotalCompra'] = number_format($subTotalCompra, 2);



                $data['subTotalVenta'] = number_format($subTotalVenta, 2);



                array_push($array['productos'], $data);



                $totalCompra += $subTotalCompra;



                $totalVenta += $subTotalVenta;



            }



        }



        $array['totalCompra'] = number_format($totalCompra, 2);



        $array['totalVenta'] = number_format($totalVenta, 2);



        echo json_encode($array, JSON_UNESCAPED_UNICODE);



        die();



    }



    //mostrar productos desde localStorage



    public function mostrarDatosPedido()



    {



        $json = file_get_contents('php://input');



        $datos = json_decode($json, true);



        $array['productos'] = array();



        $totalCompra = 0;



        $totalVenta = 0;



        $subTotalVenta = 0;



        //var_dump($datos);



        //listaCarrito = [];



        //if (localStorage.getItem("posVenta") != null) {



            //listaCarrito = JSON.parse(localStorage.getItem("posVenta"));



        //}



        //listaCarrito.forEach(productoStorage => {});



        if (!empty($datos)) {



                //$xy = 1;



            foreach ($datos as $producto) {



                $result = $this->model->editar($producto['id']);



                //$data['item'] = $xy;



                $data['id'] = $result['id'];



                $data['codigo'] = $result['codigo'];



                $data['nombre'] = $result['descripcion'];



                $data['precio_compra'] = $result['precio_compra'];



                $data['precio_venta'] = $result['precio_venta'];



                $data['precio_venta2'] = $result['precio_venta2'];



                $data['precio_venta3'] = $result['precio_venta3'];



                $data['tipo'] = $result['tipo'];



                $data['id_padre'] = $result['id_padre'];



                $data['cantidad'] = $producto['cantidad'];



                $data['stock'] = $result['cantidad'];



                $data['cantidad2'] = $result['cantidad2'];



                $subTotalCompra = $result['precio_compra'] * $producto['cantidad'];



                //$subTotalVenta = $result['precio_venta'] * $producto['cantidad'];



                $subTotalVenta = $result['precio_venta'] * $producto['cantidad'];



                $data['subTotalCompra'] = number_format($subTotalCompra, 2);



                $data['subTotalVenta'] = number_format($subTotalVenta, 2);



                array_push($array['productos'], $data);



                $totalCompra += $subTotalCompra;



                $totalVenta += $subTotalVenta;



            }



        }



        $array['totalCompra'] = number_format($totalCompra, 2);



        $array['totalVenta'] = number_format($totalVenta, 2);



        echo json_encode($array, JSON_UNESCAPED_UNICODE);



        die();



    }



    public function reporteExcel()



    {



        $spreadsheet = new Spreadsheet();







        $spreadsheet->getProperties()



            ->setCreator($_SESSION['nombre_usuario'])



            ->setTitle("Listado de Productos");







        $spreadsheet->setActiveSheetIndex(0);







        $hojaActiva = $spreadsheet->getActiveSheet();



        $hojaActiva->getColumnDimension('A')->setWidth(50);



        $hojaActiva->getColumnDimension('B')->setWidth(10);



        $hojaActiva->getColumnDimension('C')->setWidth(20);



        $hojaActiva->getColumnDimension('D')->setWidth(20);



        $hojaActiva->getColumnDimension('E')->setWidth(30);







        $spreadsheet->getActiveSheet()->getStyle('A1:E1')->getFill()



            ->setFillType(Fill::FILL_SOLID)



            ->getStartColor()->setARGB('008cff');







        $spreadsheet->getActiveSheet()->getStyle('A1:E1')



            ->getFont()->getColor()->setARGB(Color::COLOR_WHITE);







        $hojaActiva->setCellValue('A1', 'Producto');



        $hojaActiva->setCellValue('B1', 'Cantidad');



        $hojaActiva->setCellValue('C1', 'Precio Compra');



        $hojaActiva->setCellValue('D1', 'Precio Venta');



        $hojaActiva->setCellValue('E1', 'Categoria');







        $fila = 2;



        $productos = $this->model->getProductos(1);



        foreach ($productos as $producto) {



            $hojaActiva->setCellValue('A' . $fila, $producto['descripcion']);



            $hojaActiva->setCellValue('B' . $fila, $producto['cantidad']);



            $hojaActiva->setCellValue('C' . $fila, $producto['precio_compra']);



            $hojaActiva->setCellValue('D' . $fila, $producto['precio_venta']);



            $hojaActiva->setCellValue('E' . $fila, $producto['categoria']);



            $fila++;



        }







        //Generar archivo Excel



        header('Content-Type: application/vnd.ms-excel');



        header('Content-Disposition: attachment;filename="productos.xlsx"');



        $writer = IOFactory::createWriter($spreadsheet, 'Xlsx');



        $writer->save('php://output');



    }







    public function reportePdf()



    {



        ob_start();



        $data['title'] = 'Listado de Productos';



        $data['empresa'] = $this->model->getEmpresa();



        $data['productos'] = $this->model->getProductos(1);



        $this->views->getView('reportes', 'reportesPdf', $data);



        $html = ob_get_clean();



        $dompdf = new Dompdf();



        $options = $dompdf->getOptions();



        $options->set('isJavascriptEnabled', true);



        $options->set('isRemoteEnabled', true);



        $dompdf->setOptions($options);



        $dompdf->loadHtml($html);







        $dompdf->setPaper('A4', 'vertical');







        // Render the HTML as PDF



        $dompdf->render();







        // Output the generated PDF to Browser



        $dompdf->stream('reporte.pdf', array('Attachment' => false));



    }







    public function generarBarcode()



    {



        //$redColor = [255, 0, 0];



        $data['productos'] = $this->model->getProductos(1);



        $generator = new Picqer\Barcode\BarcodeGeneratorPNG();



        $ruta = 'assets/images/barcode/';



        foreach ($data['productos'] as $producto) {



            file_put_contents($ruta . $producto['id']. '.png', $generator->getBarcode($producto['codigo'], $generator::TYPE_CODE_128, 3, 50));



        }



        ob_start();



        $data['title'] = 'Barcode';



        $this->views->getView('reportes', 'barcode', $data);



        $html = ob_get_clean();



        $dompdf = new Dompdf();



        $options = $dompdf->getOptions();



        $options->set('isJavascriptEnabled', true);



        $options->set('isRemoteEnabled', true);



        $dompdf->setOptions($options);



        $dompdf->loadHtml($html);







        $dompdf->setPaper('A4', 'vertical');







        // Render the HTML as PDF



        $dompdf->render();







        // Output the generated PDF to Browser



        $dompdf->stream('reporte.pdf', array('Attachment' => false));



    }



}



