<?php

require 'vendor/autoload.php';



use Mike42\Escpos\Printer;

use Mike42\Escpos\EscposImage;

use Mike42\Escpos\PrintConnectors\WindowsPrintConnector;



use Dompdf\Dompdf;



class Ventas extends Controller

{

    private $id_usuario;

    public function __construct()

    {

        parent::__construct();

        session_start();

        if (empty($_SESSION['id_usuario'])) {

            header('Location: ' . BASE_URL);

            exit;

        }

        $this->id_usuario = $_SESSION['id_usuario'];

    }

    public function index()

    {

        $data['title'] = 'Ventas';

        $data['script'] = 'ventas.js';

        $data['busqueda'] = 'busqueda.js';

        $data['carrito'] = 'posVenta';

        $resultSerie = $this->model->getSerie();

        $serie = ($resultSerie['total'] == null) ? 1 : $resultSerie['total'] + 1;

        $data['serie'] = $this->generate_numbers($serie, 1, 8);

        $this->views->getView('ventas', 'index', $data);

    }



    public function registrarVenta()

    {

        $json = file_get_contents('php://input');

        $datos = json_decode($json, true);

        $array['productos'] = array();

        $total = 0;

        if (!empty($datos['productos'])) {

            //var_dump($datos['productos']);

            $fecha = date('Y-m-d');

            $hora = date('H:i:s');

            $metodo = $datos['metodo'];



            $resultSerie = $this->model->getSerie();

            $numSerie = ($resultSerie['total'] == null) ? 1 : $resultSerie['total'] + 1;



            $serie = $this->generate_numbers($numSerie, 1, 8);

            $descuento = (!empty($datos['descuento'])) ? $datos['descuento'] : 0;

            $idCliente = $datos['idCliente'];

            if (empty($idCliente)) {

                $res = array('msg' => 'EL CLIENTE ES REQUERIDO', 'type' => 'warning');

            } else if (empty($metodo)) {

                $res = array('msg' => 'EL METODO ES REQUERIDO', 'type' => 'warning');

            } else {

                $verifcarCaja = $this->model->getCaja($this->id_usuario);

                if (empty($verifcarCaja['monto_inicial'])) {

                    $res = array('msg' => 'La CAJA ESTA CERRADA DEBE APERTURAR LA CAJA.', 'type' => 'warning');

                } else {

                    foreach ($datos['productos'] as $producto) {

                        $result = $this->model->getProducto($producto['id']);

                        $data['id'] = $result['id'];

                        $data['nombre'] = $result['descripcion'];

                        //$data['precio'] = $result['precio_venta'];

                        $data['precio'] = $producto['precioVenta'];

                        $data['cantidad'] = $producto['cantidad'];

                        $data['tipo'] = $producto['tipo'];

                        $data['idPadre'] = $result['id_padre']; //ANALIZAR SI VA O NO

						

						$stockPadre = 0;

						$stockHijo = 0;

						

                        if($producto['tipo'] == 1 or $producto['tipo'] == "1"){//padre

                            $data['existenciaPadre'] = $result['cantidad'];

							$stockPadre = $result['cantidad'];

                        }else if($producto['tipo'] == 2 or $producto['tipo'] == "2"){//hijo

                            $data['existenciaHijo'] = $result['cantidad2'];

							$stockHijo = $result['cantidad2'];

                        }

                        $data['factor'] = $result['factor_entre_unidades'];

                        //$subTotal = $result['precio_venta'] * $producto['cantidad'];

                        $subTotal = $producto['precioVenta'] * $producto['cantidad'];//analizar porque tiene esta cantidad y no la que estan comprando:$producto['cantidad']

                        array_push($array['productos'], $data);

                        $total += $subTotal;

                    }

                    $datosProductos = json_encode($array['productos']);

                    

                    $venta = $this->model->registrarVenta($datosProductos, $total, $fecha, $hora, $metodo, $descuento, $serie[0], $idCliente, $this->id_usuario,$result['factor_entre_unidades']);

                    if ($venta > 0) {

                        $nuevaCantidad = 0;//ANALIZAR SI DEBE DE IR LA NUEVA CANTIDAD

                        foreach ($datos['productos'] as $producto) {

                            $result = $this->model->getProducto($producto['id']);

                            //echo $result['tipo'];

                            if($producto['tipo'] == 1 or $producto['tipo'] == "1"){//padre 35

                                //actualizar stock

                                $nuevaCantidad = $result['cantidad'] - $producto['cantidad'];//igual ak analizar: $producto['cantidad']

                                $nuevaCantidadHijo = $result['cantidad2'] - ($producto['cantidad']*$result['factor_entre_unidades']);

                                $totalVentas = $result['ventas'] + $producto['cantidad'];

                                $totalVentasHijo = $result['ventas_factor'] + ($producto['cantidad']*$result['factor_entre_unidades']);

								

								//INICIO CODIGO COLOCADO TEMPORALMENTE

								if($nuevaCantidad < 0){

									$nuevaCantidad = 0;

								}

								if($nuevaCantidadHijo < 0){

									$nuevaCantidadHijo = 0;

								}

								//FIN CODIGO COLOCADO TEMPORALMENTE

								

                                $this->model->actualizarStockPadre($nuevaCantidad, $nuevaCantidadHijo, $totalVentas, $totalVentasHijo, $result['id']);

                                $this->model->actualizarStockHijo($nuevaCantidadHijo, $totalVentasHijo, $result['id']);

                            }else{//hijo//if($producto['tipo'] == 2) 36

                                $actualizarCantidadPadre = 0;

                                //actualizar stock

                                $nuevaCantidadHijo = $result['cantidad2'] - $producto['cantidad'];

                                $totalVentasHijo = $result['ventas_factor'] + $producto['cantidad'];

								

								//INICIO CODIGO COLOCADO TEMPORALMENTE

								if($nuevaCantidadHijo < 0){

									$nuevaCantidadHijo = 0;

								}

								/*if($nuevaCantidadHijo < 0){

									$nuevaCantidadHijo = 0;

								}*/

								//FIN CODIGO COLOCADO TEMPORALMENTE

								

                                $this->model->actualizarStockOnlyHijo($nuevaCantidadHijo, $totalVentasHijo, $result['id']);



                                //ESTE CODIGO AUN ESTA DE PRUEBA HAY QUE REALIZAR CORRECIONES

                                if($result['id_padre'] > 0){//aplicar validaciones para que no se haga division entre cero

                                    $resultPadre= $this->model->getProducto($result['id_padre']);

                                    

                                    //$actualizarCantidadPadre = ($nuevaCantidadHijo / $resultPadre['factor_entre_unidades']);

                                    $nuevaCantidadHijoPadre = $resultPadre['cantidad2'] - $producto['cantidad'];

									//INICIO CODIGO COLOCADO TEMPORALMENTE

									if($nuevaCantidadHijoPadre < 0){

										$nuevaCantidadHijoPadre = 0;

									}									

									//FIN CODIGO COLOCADO TEMPORALMENTE

                                    $actualizarCantidadPadre = ($nuevaCantidadHijoPadre / $resultPadre['factor_entre_unidades']);

									

                                    if(($nuevaCantidadHijoPadre%$resultPadre['factor_entre_unidades']) == 0){

                                       $totalVentas = $result['ventas'] + 1;

                                    }else{

                                        $totalVentas = $result['ventas'];

                                    }

                                    

                                    $this->model->actualizarStockPadre($actualizarCantidadPadre, $nuevaCantidadHijoPadre, $totalVentas, $totalVentasHijo, $result['id_padre']);

                                    //FALTA EL CODIGO PARA VERIFICAR SI EL PADRE TIENE COMPLETA LA CAJA O NO



                                }

                                

                                //$actualizarCantidadPadre = number_format($result['cantidad2'] / $result['factor_entre_unidades'],0);

                                //if($result['cantidad'] == $actualizarCantidadPadre){



                                //}else{//

                                    //$this->model->actualizarStockPadre($actualizarCantidadPadre, $nuevaCantidadHijo, $totalVentas, $totalVentasHijo, $result['id']);

                                //}

                            }



                            $movimiento = 'Venta N°: ' . $venta;

                            $cantidad = $producto['cantidad'];

                            $this->model->registrarMovimiento($movimiento, 'salida', $cantidad, $nuevaCantidad, $producto['id'], $this->id_usuario);

                        }

                        if ($metodo == 'CREDITO') {

                            $monto = $total - $descuento;

                            $this->model->registrarCredito($monto, $fecha, $hora, $venta);

                        }

                        if ($datos['impresion']) {

                            //$this->impresionDirecta($venta);//no borrar

                        }

                        $res = array('msg' => 'VENTA GENERADA', 'type' => 'success', 'idVenta' => $venta);

                    } else {

                        $res = array('msg' => 'ERROR AL GENERAR VENTA', 'type' => 'error');

                    }

                }

            }

        } else {

            $res = array('msg' => 'CARRITO VACIO', 'type' => 'warning');

        }

        echo json_encode($res);

        die();

    }



    public function reporte($datos)

    {

        ob_start();

        $array = explode(',', $datos);

        $tipo = $array[0];

        $idVenta = $array[1];



        $data['title'] = 'Reporte';

        $data['empresa'] = $this->model->getEmpresa();

        $data['venta'] = $this->model->getVenta($idVenta);

        if (empty($data['venta'])) {

            echo 'Pagina no Encontrada';

            exit;

        }

        $this->views->getView('ventas', $tipo, $data);

        $html = ob_get_clean();

        $dompdf = new Dompdf();

        $options = $dompdf->getOptions();

        $options->set('isJavascriptEnabled', true);

        $options->set('isRemoteEnabled', true);

        $dompdf->setOptions($options);

        $dompdf->loadHtml($html);



        if ($tipo == 'ticked') {

            $dompdf->setPaper(array(0, 0, 130, 841), 'portrait');

        } else {

            $dompdf->setPaper('A4', 'vertical');

        }



        // Render the HTML as PDF

        $dompdf->render();



        // Output the generated PDF to Browser

        $dompdf->stream('reporte.pdf', array('Attachment' => false));

    }



    public function listar()

    {

        $data = $this->model->getVentas();

        for ($i = 0; $i < count($data); $i++) {

            if ($data[$i]['estado'] == 1) {

                $data[$i]['acciones'] = '<div>

                <a class="btn btn-warning" href="#" onclick="anularVenta(' . $data[$i]['id'] . ')"><i class="fas fa-trash"></i></a>

                <a class="btn btn-danger" href="#" onclick="verReporte(' . $data[$i]['id'] . ')"><i class="fas fa-file-pdf"></i></a>

                </div>';

            } else {

                $data[$i]['acciones'] = '<div>

                <span class="badge bg-info">Anulado</span>

                <a class="btn btn-danger" href="#" onclick="verReporte(' . $data[$i]['id'] . ')"><i class="fas fa-file-pdf"></i></a>

                </div>';

            }

        }

        echo json_encode($data);

        die();

    }



    public function anular($idVenta)

    {

        if (isset($_GET) && is_numeric($idVenta)) {

            $data = $this->model->anular($idVenta);

            if ($data == 1) {

                $resultVenta = $this->model->getVenta($idVenta);

                $ventaProducto = json_decode($resultVenta['productos'], true);

                foreach ($ventaProducto as $producto) {

                    $result = $this->model->getProducto($producto['id']);

                    $nuevaCantidad = $result['cantidad'] + $producto['cantidad'];

                    $totalVentas = $result['ventas'] - $producto['cantidad'];

                    $this->model->actualizarStock($nuevaCantidad, $totalVentas, $producto['id']);



                    //movimientos

                    $movimiento = 'Devolución Venta N°: ' . $idVenta;

                    $this->model->registrarMovimiento($movimiento, 'entrada', $producto['cantidad'], $nuevaCantidad, $producto['id'], $this->id_usuario);

                }

                if ($resultVenta['metodo'] == 'CREDITO') {

                    $this->model->anularCredito($idVenta);

                }

                $res = array('msg' => 'VENTA ANULADO', 'type' => 'success');

            } else {

                $res = array('msg' => 'ERROR AL ANULAR', 'type' => 'error');

            }

        } else {

            $res = array('msg' => 'ERROR DESCONOCIDO', 'type' => 'error');

        }

        echo json_encode($res);

        die();

    }



    public function impresionDirecta($idVenta)

    {

        $empresa = $this->model->getEmpresa();

        $venta = $this->model->getVenta($idVenta);

        $nombre_impresora = "POS-58-Series";

        $connector = new WindowsPrintConnector($nombre_impresora);

        $printer = new Printer($connector);



        # Vamos a alinear al centro lo próximo que imprimamos

        $printer->setJustification(Printer::JUSTIFY_CENTER);



        /*

            Intentaremos cargar e imprimir

            el logo

        */

        try {

            $logo = EscposImage::load("assets/images/logo.png", false);

            $printer->bitImage($logo);

        } catch (Exception $e) {/*No hacemos nada si hay error*/

        }



        /*

            Ahora vamos a imprimir un encabezado

        */



        $printer->text($empresa['nombre'] . "\n");

        $printer->text('RTU: ' . $empresa['ruc'] . "\n");

        $printer->text('Telefono: ' . $empresa['telefono'] . "\n");

        $printer->text('Dirección: ' . $empresa['direccion'] . "\n");

        #La fecha también

        $printer->text(date("Y-m-d H:i:s") . "\n\n");



        #Datos del cliente

        $printer->text('Datos del Cliente' . "\n");

        $printer->text('--------------------' . "\n");

        /*Alinear a la izquierda para la cantidad y el nombre*/

        $printer->setJustification(Printer::JUSTIFY_LEFT);

        $printer->text($venta['identidad'] . ': ' . $venta['num_identidad'] . "\n");

        $printer->text('Nombre: ' . $venta['nombre'] . "\n");

        $printer->text('Telefono: ' . $venta['telefono'] . "\n");

        $printer->text('Dirección: ' . $venta['direccion'] . "\n\n");



        $printer->setJustification(Printer::JUSTIFY_CENTER);

        $printer->text('Detalles del Producto' . "\n");

        $printer->text('--------------------' . "\n");

        $productos = json_decode($venta['productos'], true);

        foreach ($productos as $producto) {

            /*Alinear a la izquierda para la cantidad y el nombre*/

            $printer->setJustification(Printer::JUSTIFY_LEFT);

            $printer->text($producto['cantidad'] . "x" . $producto['nombre'] . "\n");



            /*Y a la derecha para el importe*/

            $printer->setJustification(Printer::JUSTIFY_RIGHT);

            $printer->text(MONEDA . number_format($producto['precio'], 2) . "\n");

        }



        /*

            Terminamos de imprimir

            los productos, ahora va el total

        */

        $printer->text("--------\n");

        $printer->text("Descuento: " . MONEDA . number_format($venta['descuento'], 2) . "\n");

        $printer->text("--------\n");

        $printer->text("TOTAL: " . MONEDA . number_format($venta['total'] - $venta['descuento'], 2) . "\n\n");





        /*

            Podemos poner también un pie de página

        */

        $printer->text($empresa['mensaje']);







        /*Alimentamos el papel 3 veces*/

        $printer->feed(3);



        /*

            Cortamos el papel. Si nuestra impresora

            no tiene soporte para ello, no generará

            ningún error

        */

        $printer->cut();



        /*

            Por medio de la impresora mandamos un pulso.

            Esto es útil cuando la tenemos conectada

            por ejemplo a un cajón

        */

        $printer->pulse();



        /*

            Para imprimir realmente, tenemos que "cerrar"

            la conexión con la impresora. Recuerda incluir esto al final de todos los archivos

        */

        $printer->close();

    }



    public function verificarStock($idProducto)

    {

        $data = $this->model->getProducto($idProducto);

        echo json_encode($data);

        die();

    }



    /*public function actualizarPrecio($idProducto)

    {

        $data = $this->model->getProducto($idProducto);

        echo json_encode($data);

        die();

    }*/



    function generate_numbers($start, $count, $digits)

    {

        $result = array();

        for ($n = $start; $n < $start + $count; $n++) {

            $result[] = str_pad($n, $digits, "0", STR_PAD_LEFT);

        }

        return $result;

    }

}

