<?php
namespace App\Controllers;
use App\DB\DBConnection;
use App\Utility\UtilityDB;
use PDOException;


class TraClienteController {
	
    public function select($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_Cliente', 'lectura');
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $fecha_ini = $parameter['fecha_ini'] ?? "01/01/1900";
                    $fecha_fin = $parameter['fecha_fin'] ?? "01/01/1900";
                    $pag_inicio = $parameter['pag_inicio'] ?? 0;
                    $tamanio = $parameter['tamanio'] ?? 10;
                    $filter = $parameter['filter'] ?? "undefined";
                    if(empty($filter)) $filter = "undefined";

                    $filter1 = $parameter['filter1'] ?? "undefined";
                    if(empty($filter1)) $filter1 = "undefined";

                    $filter2 = $parameter['filter2'] ?? "undefined";
                    if(empty($filter2)) $filter2 = "undefined";


                    $cli_estado = $parameter['cli_estado'] ?? 'A';

					/*
                    concat(b.usr_nombres,' ',b.usr_apellidos) as cli_usuarioi,  
                    concat(c.usr_nombres,' ',c.usr_apellidos) as cli_usuariom,*/
                    $sql = " 
                    select 
                    a.cli_correl, 
                    LPAD(a.cli_correl,10,'0') cli_codigo, 
                    concat('CDM',a.cli_correl) cli_codigo, 
                    a.cli_nombre,  
                    a.cli_nit,  
                    a.cli_direccion,  
                    a.cli_telefono,  
                    a.cli_email,  
                    a.cli_nombre_contacto,
                    a.cli_correo_contacto,
                    a.cli_telefono_contacto,
                    a.cli_estado,
                    a.cli_fechai,  
                    a.cli_fecham,
                    concat(u1.usr_nombres , ' ' , u1.usr_apellidos) as usr_ing,
                    date_format(cli_fechai, '%d/%m/%y %T') as usr_fechai,
                    concat(u2.usr_nombres , ' ' , u2.usr_apellidos) as usr_mod,
                    date_format(cli_fecham, '%d/%m/%y %T') as usr_fecham 
                    from tra_clientes a 
                    left outer join cfg_catalogo d on(a.cli_estado= d.cat_valor and d.cat_tipo = 'CLIENTE_ESTADO' and d.cat_empresa = :emp_codigo and d.cat_estado = 'A')
                    left outer join cfg_usuario u1 on (u1.usr_correl = a.cli_usuarioi)
                    left outer join cfg_usuario u2 on (u2.usr_correl = a.cli_usuariom) 
                    where 1=1 
                    and a.cli_estado =:cli_estado 
                    and ((a.cli_correl like concat('%',:filter,'%') or a.cli_nombre like concat('%',:filter,'%') or a.cli_direccion like concat('%',:filter,'%') or a.cli_nit like concat('%',:filter,'%')) or (:filter = 'undefined'))
                    and (a.cli_fechai >=STR_TO_DATE(:fecha_ini,'%d/%m/%y %T') OR :fecha_ini='01/01/1900') 
                    and (a.cli_fechai <=STR_TO_DATE(:fecha_fin,'%d/%m/%y %T') OR :fecha_fin='01/01/1900') 
                     limit $pag_inicio, $tamanio ";

                    $stmt = $PDO->prepare($sql);
                    $stmt->execute([
                    'cli_estado' => $cli_estado,
                    'emp_codigo' => $emp_codigo,
                    'fecha_ini' => $fecha_ini,
                    'fecha_fin' => $fecha_fin,
                    'filter' => ltrim($filter,'CDM')
                    ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                    
                    if (!empty($stmt)) {
                        $totalRegistros = $utility->RegistrosTotal($PDO, "tra_clientes a 
                        left outer join cfg_catalogo d on(a.cli_estado= d.cat_valor and d.cat_tipo = 'CLIENTE_ESTADO' and d.cat_empresa = :emp_codigo) 
                        left outer join cfg_usuario b on (b.usr_correl = a.cli_usuarioi) 
                        left outer join cfg_usuario c on (c.usr_correl = a.cli_usuariom) 
                        ", "   and a.cli_estado =:cli_estado  
                         and ((a.cli_correl like concat('%',:filter,'%') or a.cli_nombre like concat('%',:filter,'%') or a.cli_nit like concat('%',:filter,'%')) or (:filter = 'undefined'))
                         and (a.cli_fechai >=STR_TO_DATE(:fecha_ini,'%d/%m/%y %T') OR :fecha_ini='01/01/1900') 
                         and (a.cli_fechai <=STR_TO_DATE(:fecha_fin,'%d/%m/%y %T') OR :fecha_fin='01/01/1900') 
                        ", 
                        [
                        'cli_estado' => $cli_estado,
                        'emp_codigo' => $emp_codigo,
                        'fecha_ini' => $fecha_ini,
                        'fecha_fin' => $fecha_fin,
                        'filter' => ltrim($filter,'CDM')
                        ]);
                        //$totalRegistros =$stmt->rowCount();

                        /*para combos

                        if($totalRegistros > 0){
                            array_unshift($result,array("pro_correl"=>'','pro_nombre'=>'Seleccione un proveedor'));
                        }else{
                            array_unshift($result,array("pro_correl"=>'','pro_nombre'=>'No existen proveedores disponibles'));
                        }*/

                        $data = array('estado'=>'OK', 'data'=>$result, 'status'=>200,'token'=>$token,'totalRegistros'=>$totalRegistros);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }
    public function insert($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();  
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $pro_sucursal = 1;

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_Cliente', 'nuevo');

                if($userFuncionality == 'OK'){
                    $cli_nombre=$parameter['cli_nombre'] ?? 'SN';
                    $cli_nit=$parameter['cli_nit'] ?? 'cf';
                    $cli_imagen=$parameter['cli_imagen'] ?? NULL;
                    if($cli_imagen != 'undefined' && $cli_imagen != 'null'){$cli_imagen = $parameter['cli_imagen'];}else{$cli_imagen = NULL;}
                    $cli_direccion=$parameter['cli_direccion'] ?? NULL;
                    if($cli_direccion != 'undefined' && $cli_direccion != 'null'){$cli_direccion = $parameter['cli_direccion'];}else{$cli_direccion = NULL;}
                    $cli_telefono=$parameter['cli_telefono'] ?? NULL;
                    if($cli_telefono != 'undefined' && $cli_telefono != 'null'){$cli_telefono = $parameter['cli_telefono'];}else{$cli_telefono = NULL;}
                    $cli_email=$parameter['cli_email'] ?? NULL;
                    if($cli_email != 'undefined' && $cli_email != 'null'){$cli_email = $parameter['cli_email'];}else{$cli_email = NULL;}
                    $cli_nombre_contacto=$parameter['cli_nombre_contacto'] ?? NULL;
                    if($cli_nombre_contacto != 'undefined' && $cli_nombre_contacto != 'null'){$cli_nombre_contacto = $parameter['cli_nombre_contacto'];}else{$cli_nombre_contacto = NULL;}
                    $cli_correo_contacto=$parameter['cli_correo_contacto'] ?? NULL;
                    if($cli_correo_contacto != 'undefined' && $cli_correo_contacto != 'null'){$cli_correo_contacto = $parameter['cli_correo_contacto'];}else{$cli_correo_contacto = NULL;}
                    $cli_telefono_contacto=$parameter['cli_telefono_contacto'] ?? NULL;
                    if($cli_telefono_contacto != 'undefined' && $cli_telefono_contacto != 'null'){$cli_telefono_contacto = $parameter['cli_telefono_contacto'];}else{$cli_telefono_contacto = NULL;}
                    $cli_estado=$parameter['cli_estado'] ?? 'A';

                    $cli_correl = $utility->CorrelAutomatico($PDO, "tra_clientes", "cli_correl", "");
                    $cli_codigo = $utility->CorrelAutomatico($PDO, "tra_clientes", "cli_codigo", " and cli_empresa = $emp_codigo");//solucionar
                    
                    
                    $existeCorreo = 0;$existeNit = 0;
                    $cli_sucursal = 1;
					/*$existeCorreo = $utility->buscarRegistro($PDO, "tra_clientes", "pro_correl dato,cli_email", " and UPPER(cli_email)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_email);
                    
                    
                    if($cli_nit == "CF" || $cli_nit == "cf"){
                        $existeNit = 0;
                    }else{
                        $existeNit = $utility->buscarRegistro($PDO, "tra_clientes", "pro_correl dato,cli_nit", " and UPPER(cli_nit)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_nit);
                    }*/
                    
                    
                    $sql = "insert into tra_clientes (
                              cli_correl,
                              cli_codigo,
                              cli_empresa,
                              cli_ambiente,
                              cli_sucursal,
                              cli_nombre,
                              cli_imagen,
                              cli_nit,
                              cli_direccion,
                              cli_telefono,
                              cli_email,
                              cli_nombre_contacto,
                              cli_correo_contacto,
                              cli_telefono_contacto,
                              cli_estado,
                              cli_usuarioi,
                              cli_usuariom,
                              cli_fechai,
                              cli_fecham
                            ) values(
                              :cli_correl,
                              :cli_codigo,
                              :cli_empresa,
                              :cli_ambiente,
                              :cli_sucursal,
                              :cli_nombre,
                              :cli_imagen,
                              :cli_nit,
                              :cli_direccion,
                              :cli_telefono,
                              :cli_email,
                              :cli_nombre_contacto,
                              :cli_correo_contacto,
                              :cli_telefono_contacto,
                              :cli_estado,
                              :id_usuario, 
                              :id_usuario, 
                              now(), 
                              now() 
                            )
                    ";

                    $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correl' => $cli_correl,
                        'cli_codigo' => $cli_codigo,
                        'cli_empresa' => $emp_codigo,
                        'cli_ambiente' => $amb_codigo,
                        'cli_sucursal' => $cli_sucursal,

                        'cli_nombre' => $cli_nombre,
                        'cli_imagen' => $cli_imagen,
                        'cli_nit' => $cli_nit,
                        'cli_direccion' => $cli_direccion,
                        'cli_telefono' => $cli_telefono,
                        'cli_email' => $cli_email,
                        'cli_nombre_contacto' => $cli_nombre_contacto,
                        'cli_correo_contacto' => $cli_correo_contacto,
                        'cli_telefono_contacto' => $cli_telefono_contacto,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                    ]);
                        
                        
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Cliente registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$cli_correl,'keyCorrel'=>$cli_codigo);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'Cliente no pudo ser registrado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }

                    if($existeCorreo > 0 || $existeNit > 0){
                        $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(400);
                    }else{
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        
                        
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$cli_correlativo);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser registrado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    public function update($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $cli_sucursal = 1;

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_Cliente', 'modificar');
                if($userFuncionality == 'OK'){
                    
                    $cli_correl=$parameter['cli_correl'] ?? 0;
                    $cli_nombre=$parameter['cli_nombre'] ?? 'SN';
                    $cli_nit=$parameter['cli_nit'] ?? 'cf';
                    $cli_imagen=$parameter['cli_imagen'] ?? NULL;
                    if($cli_imagen != 'undefined' && $cli_imagen != 'null'){$cli_imagen = $parameter['cli_imagen'];}else{$cli_imagen = NULL;}
                    $cli_direccion=$parameter['cli_direccion'] ?? NULL;
                    if($cli_direccion != 'undefined' && $cli_direccion != 'null'){$cli_direccion = $parameter['cli_direccion'];}else{$cli_direccion = NULL;}
                    $cli_telefono=$parameter['cli_telefono'] ?? NULL;
                    if($cli_telefono != 'undefined' && $cli_telefono != 'null'){$cli_telefono = $parameter['cli_telefono'];}else{$cli_telefono = NULL;}
                    $cli_email=$parameter['cli_email'] ?? NULL;
                    if($cli_email != 'undefined' && $cli_email != 'null'){$cli_email = $parameter['cli_email'];}else{$cli_email = NULL;}
                    $cli_nombre_contacto=$parameter['cli_nombre_contacto'] ?? NULL;
                    if($cli_nombre_contacto != 'undefined' && $cli_nombre_contacto != 'null'){$cli_nombre_contacto = $parameter['cli_nombre_contacto'];}else{$cli_nombre_contacto = NULL;}
                    $cli_correo_contacto=$parameter['cli_correo_contacto'] ?? NULL;
                    if($cli_correo_contacto != 'undefined' && $cli_correo_contacto != 'null'){$cli_correo_contacto = $parameter['cli_correo_contacto'];}else{$cli_correo_contacto = NULL;}
                    $cli_telefono_contacto=$parameter['cli_telefono_contacto'] ?? NULL;
                    if($cli_telefono_contacto != 'undefined' && $cli_telefono_contacto != 'null'){$cli_telefono_contacto = $parameter['cli_telefono_contacto'];}else{$cli_telefono_contacto = NULL;}
                    $cli_estado=$parameter['cli_estado'] ?? 'A';
                    


                    /*$existeCorreo = $utility->buscarRegistro($PDO, "tra_clientes", "cli_correl dato,cli_email", " and UPPER(cli_email)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_email);

                    if($cli_nit == "CF" || $cli_nit == "cf"){
                        $existeNit = 0;
                    }else{
                        $existeNit = $utility->buscarRegistro($PDO, "tra_clientes", "cli_correl dato,cli_nit", " and UPPER(cli_nit)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_nit);
                    }*/
                    

                    $sql = " update tra_clientes set
                        					cli_sucursal = :cli_sucursal,  
											cli_nombre = :cli_nombre,  
											cli_imagen = :cli_imagen,  
											cli_nit = :cli_nit,  
											cli_direccion = :cli_direccion,  
											cli_telefono = :cli_telefono,  
											cli_email = :cli_email,  
											cli_nombre_contacto = :cli_nombre_contacto,  
											cli_correo_contacto = :cli_correo_contacto,
                                            cli_telefono_contacto = :cli_telefono_contacto,
                                            cli_estado = :cli_estado,
                                            cli_usuariom = :id_usuario,
											cli_fecham=now() 
                                            where cli_correl=:cli_correl";

                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correl' => $cli_correl,
                        //'cli_codigo' => $cli_codigo,
                        //'cli_empresa' => $emp_codigo,
                        //'cli_ambiente' => $amb_codigo,
                        'cli_sucursal' => $cli_sucursal,
                        'cli_nombre' => $cli_nombre,
                        'cli_imagen' => $cli_imagen,
                        'cli_nit' => $cli_nit,
                        'cli_direccion' => $cli_direccion,
                        'cli_telefono' => $cli_telefono,
                        'cli_email' => $cli_email,
                        'cli_nombre_contacto' => $cli_nombre_contacto,
                        'cli_correo_contacto' => $cli_correo_contacto,
                        'cli_telefono_contacto' => $cli_telefono_contacto,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                    ]);
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Cliente actualizado exitosamente', 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'Cliente no pudo ser actualizado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }    
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){//&& $cli_correlativo <> $existeCorreo
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){//&& $cli_correlativo <> $existeNit
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }
                    if($cli_correlativo == $existeCorreo && $cli_correlativo == $existeNit){//
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }else{
                        if(($existeCorreo > 0 && $cli_correlativo <> $existeCorreo) && ($existeNit > 0 && $cli_correlativo == $existeNit)){//|| $existeNit > 0
                            $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(400);
                        }else{//Registro no existe
                            $stmt = $PDO->prepare($sql);
                            $result = $stmt->execute([
                                'cli_correlativo' => $cli_correlativo,
                                'cli_nombre' => $cli_nombre,
                                'cli_email' => $cli_email,
                                'cli_facturar' => $cli_facturar,
                                'cli_nit' => $cli_nit,
                                'cli_telefono1' => $cli_telefono1,
                                'cli_telefono2' => $cli_telefono2,
                                'cli_direccion' => $cli_direccion,
                                'cli_estado' => $cli_estado,
                                'id_usuario' => $id_usuario
                            ]);
                            if ($result == true) {
                                $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(200);
                            }else{
                                $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(403);
                            }
                        }
                        //$data = array('estado'=>'ERROR', 'mensaje'=>'Registro duplicado', 'status'=>400,'token'=>$token);//'Registro duplicado'
                        //$payload = json_encode($data);
                        //$response->getBody()->write($payload);
                        //$response = $response->withStatus(400);
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    public function delete($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_Cliente', 'eliminar');
                if($userFuncionality == 'OK'){
                    
                    $cli_correl=$parameter['cli_correl'] ?? 0;
                    
                    
                    $sql = " update tra_clientes set cli_estado = 'E' where cli_correl = :cli_correl";
        
                    $stmt = $PDO->prepare($sql);
                    $result = $stmt->execute([
                        'cli_correl' => $cli_correl
                    ]);
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Cliente eliminado exitosamente', 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'Cliente no pudo ser eliminado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    //sin usar cliente
    public function getSign($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_recepcion', 'lectura');
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $att_objeto_codigo = $parameter['att_objeto_codigo'] ?? 0;
                    $att_objeto = $parameter['att_objeto'] ?? 'no_object';
                    
                    $download_dir = DOWNLOAD_DIR_FIRMA;                    

					
                    $sql = "select concat('$download_dir', to_char(att_fechai,'YYYY'),'/',to_char(att_fechai,'MM'),att_archivo) as firma from tra_attachment
                    where 
                    att_objeto_codigo = :att_objeto_codigo and att_objeto = :att_objeto and att_estado = 'A'
                    ";
                    
                    $stmt = $PDO->prepare($sql);
                    $stmt->execute(['att_objeto' => $att_objeto,
                    'att_objeto_codigo' => $att_objeto_codigo
                    ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                    
                    if (!empty($result)) {
                        
                        $path = $result[0]->firma;
                        $type = pathinfo($path, PATHINFO_EXTENSION);
                        $data = file_get_contents($path);
                        $base64 = 'data:image/' . $type . ';base64,' . base64_encode($data);
                        
                        
                        $data = array('estado'=>'OK', 'data'=>$base64, 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }
   
    
}
