<?php
namespace App\Controllers;
use App\DB\DBConnection;
use App\Utility\UtilityDB;
use PDOException;


class TraPedidoController {
	
	public function select($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
				
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'lectura');
				
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $fecha_ini = $parameter['fecha_ini'] ?? "01/01/1900";
                    $fecha_fin = $parameter['fecha_fin'] ?? "01/01/1900";
                    $pag_inicio = $parameter['pag_inicio'] ?? 0;
                    $tamanio = $parameter['tamanio'] ?? 10;
                    $filter = $parameter['filter'] ?? "undefined";
                    if(empty($filter)) $filter = "undefined";
                    $ped_estado = 'E';//$parameter['ped_estado'] ?? 'I';

					//IF(a.pro_clasificacion = 1, 'Producto','Servicio médico') as servicio,
					//left outer join cfg_catalogo d on(a.pro_estado= d.cat_valor and d.cat_tipo = 'ESTADO_PRODUCTO' and d.cat_empresa = :emp_codigo)
                    //date_format(a.ped_fecha_entrega, '%d/%m/%y %T') as ped_fecha_entrega,
                    $sql = " 
                    select 
                    a.ped_id, 
                    a.ped_usr_correl, 
                    a.ped_nombre_cliente, 
                    a.ped_nombre_negocio,
                    a.ped_observaciones,  
                    a.ped_direccion_entrega,  
                    a.ped_telefono_contacto,  
                    a.ped_usr_cliente,  
                    a.ped_estado,
                    d.cat_nombre as flag_estado,
                    d.cat_codigo_ext as flag_bk_estado,
                    a.ped_usuarioi,
                    a.ped_usuariom, 
                    concat(b.usr_nombres,' ', b.usr_apellidos) as ped_usuarioi,  
                    concat(c.usr_nombres,' ', c.usr_apellidos) as ped_usuariom, 
                    date_format(a.ped_fechai, '%d/%m/%y %T') as ped_fechai,  
                    date_format(a.ped_fecham, '%d/%m/%y %T') as ped_fecham,  
                    a.ped_descripcion_cancelacion,
                    a.ped_fecha_cancelacion,
                    FORMAT((SELECT sum((ifnull(d1.pdet_cantidad,0) * ifnull(d1.pdet_precio_venta,0))) FROM tra_pedidos_detalle d1 WHERE 1=1 and d1.pdet_estado != 'E' and d1.pdet_ped_id = a.ped_id),2) as ped_importe,
                    FORMAT((SELECT sum(d2.pdet_cantidad) FROM tra_pedidos_detalle d2 WHERE 1=1 and d2.pdet_estado != 'E' and d2.pdet_ped_id = a.ped_id),0) as ped_total_item 
                    
                    from tra_pedidos a 
                    left outer join cfg_catalogo d on(a.ped_estado= d.cat_valor and d.cat_tipo = 'ESTADO_PEDIDOS' and d.cat_estado = 'A') 
                    left outer join cfg_usuario b on (b.usr_correl = a.ped_usuarioi) 
                    left outer join cfg_usuario c on (c.usr_correl = a.ped_usuariom) 
                    where 1=1 and a.ped_estado not in('E','V')  
                    and ((a.ped_observaciones like concat('%',:filter,'%') or a.ped_telefono_contacto like concat('%',:filter,'%')) or (:filter = 'undefined')) 
                     
                    and (a.ped_fechai >=str_to_date(:fecha_ini|| '00:00','%d,%m,%Y') OR :fecha_ini='01/01/1900') 
                    and (a.ped_fechai <=str_to_date(:fecha_fin|| '23:59','%d,%m,%Y') OR :fecha_fin='01/01/1900') 
					ORDER BY a.ped_id DESC     
                    limit $pag_inicio, $tamanio";
                    //and a.ped_estado !=:ped_estado
                    //echo $sql;
                    $stmt = $PDO->prepare($sql);
                    $stmt->execute([
                        //'ped_estado' => $ped_estado,
                        'fecha_ini' => $fecha_ini,
                        'fecha_fin' => $fecha_fin,
                        'filter' => $filter,
                        ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                    //and a.ped_estado !=:ped_estado 
                    if (!empty($stmt)) {
                        $totalRegistros =$utility->RegistrosTotal($PDO, "tra_pedidos a
                        	left outer join cfg_catalogo d on(a.ped_estado= d.cat_valor and d.cat_tipo = 'ESTADO_PEDIDOS' and d.cat_estado = 'A') 
		                    left outer join cfg_usuario b on (b.usr_correl = a.ped_usuarioi) 
                    		left outer join cfg_usuario c on (c.usr_correl = a.ped_usuariom) 
                            ", " and a.ped_estado not in('E','V') 
                            and ((a.ped_observaciones like concat('%',:filter,'%') or a.ped_telefono_contacto like concat('%',:filter,'%')) or (:filter = 'undefined')) 
		                   
		                    and (a.ped_fechai >=str_to_date(:fecha_ini|| '00:00','%d,%m,%Y') OR :fecha_ini='01/01/1900') 
		                    and (a.ped_fechai <=str_to_date(:fecha_fin|| '23:59','%d,%m,%Y') OR :fecha_fin='01/01/1900') 
                            ", 
                            [
                            //'ped_estado' => $ped_estado,
                            'fecha_ini' => $fecha_ini,
                            'fecha_fin' => $fecha_fin,
                            'filter' => $filter,
                            ]);
                        
                        $data = array('estado'=>'OK', 'data'=>$result, 'status'=>200,'token'=>$token,'totalRegistros'=>$totalRegistros);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }
	
	public function selectProducto($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'lectura');
				
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $fecha_ini = $parameter['fecha_ini'] ?? "01/01/1900";
                    $fecha_fin = $parameter['fecha_fin'] ?? "01/01/1900";
                    $pag_inicio = $parameter['pag_inicio'] ?? 0;
                    $tamanio = $parameter['tamanio'] ?? 10;
                    $filter = $parameter['filter'] ?? "undefined";
                    if(empty($filter)) $filter = "undefined";
                    $estado = $parameter['estado'] ?? 'A';

					//IF(a.pro_clasificacion = 1, 'Producto','Servicio médico') as servicio,
					//left outer join cfg_catalogo d on(a.pro_estado= d.cat_valor and d.cat_tipo = 'ESTADO_PRODUCTO' and d.cat_empresa = :emp_codigo)
					//FORMAT(a.precio_venta,2) as precio_venta,  
					//if(tipo = 1, cantidad,cantidad2) as stock,
					//if(a.tipo = 1, a.cantidad, '---------------') as stockPadre,
					//if(a.tipo = 2, a.cantidad2, 0) as stockHijo,
					//a.cantidad,
                    //a.cantidad2 
                    $sql = " 
                    select 
                    a.id, 
                    a.codigo,  
                    CONCAT(a.descripcion,' (',TRUNCATE(if(a.tipo = 1, a.cantidad,a.cantidad2),0),' Existencias)') AS descripcion,
                    FORMAT(a.precio_compra,2) as precio_compra,
                    a.precio_venta,
                    FORMAT(a.precio_venta,2) as precio_venta_format,
                    a.tipo,
                    a.id_padre,
                    TRUNCATE(if(a.tipo = 1, a.cantidad,a.cantidad2),0) as cantidad 
                    from productos a 
                    where 1=1 and a.estado = 1  
                    and ((UPPER(a.descripcion) like UPPER(concat('%',:filter,'%'))) or (:filter = 'undefined')) 
                    limit $pag_inicio, $tamanio";
                    //echo $sql;
                    $stmt = $PDO->prepare($sql);
                    $stmt->execute([
                        //'estado' => $estado,
                        'filter' => $filter,
                        ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                   
                    if (!empty($stmt)) {
                        $totalRegistros =$utility->RegistrosTotal($PDO, "productos a
                            ", " and a.estado = 1 
                            and ((a.descripcion like concat('%',:filter,'%')) or (:filter = 'undefined'))  
                            ", 
                            [
                            //'estado' => $estado,
                            'filter' => $filter,
                            ]);
                        
                        $data = array('estado'=>'OK', 'data'=>$result, 'status'=>200,'token'=>$token,'totalRegistros'=>$totalRegistros);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }

	public function selectPedidoDetalle($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'lectura');
				
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $fecha_ini = $parameter['fecha_ini'] ?? "01/01/1900";
                    $fecha_fin = $parameter['fecha_fin'] ?? "01/01/1900";
                    $pag_inicio = $parameter['pag_inicio'] ?? 0;
                    $tamanio = $parameter['tamanio'] ?? 10;
                    $filter = $parameter['filter'] ?? 0;
                    if(empty($filter)) $filter = 0;
                    $estado = $parameter['estado'] ?? 'A';

					//IF(a.pro_clasificacion = 1, 'Producto','Servicio médico') as servicio,
					//left outer join cfg_catalogo d on(a.pro_estado= d.cat_valor and d.cat_tipo = 'ESTADO_PRODUCTO' and d.cat_empresa = :emp_codigo)
                    $sql = " 
                    select 
                    a.pdet_correl, 
                    a.pdet_ped_id, 
                    a.pdet_id, 
                    a.pdet_descripcion_producto,
                    a.pdet_cantidad,
                    FORMAT(a.pdet_precio_venta,2) as pdet_precio_venta   
                    from tra_pedidos_detalle a 
                    where 1=1 and a.pdet_estado = 'A'
                    and a.pdet_ped_id =:filter 
                    ORDER BY a.pdet_correl DESC 
                    limit $pag_inicio, $tamanio";
                    //echo $sql;
                    $stmt = $PDO->prepare($sql);
                    $stmt->execute([
                        //'estado' => $estado,
                        'filter' => $filter,
                        ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                   
                    if (!empty($stmt)) {
                        $totalRegistros =$utility->RegistrosTotal($PDO, "tra_pedidos_detalle a
                            ", " and a.pdet_estado = 'A'  
                            and a.pdet_ped_id =:filter  
                            ", 
                            [
                            //'estado' => $estado,
                            'filter' => $filter,
                            ]);
                        
                        $data = array('estado'=>'OK', 'data'=>$result, 'status'=>200,'token'=>$token,'totalRegistros'=>$totalRegistros);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }

    public function insert($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();  
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $pro_sucursal = 1;

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'nuevo');

                if($userFuncionality == 'OK'){
                	
                	$ped_usr_correl=$id_usuario;//$parameter['ped_usr_correl'] ?? 0;
					$ped_nombre_cliente=$parameter['ped_nombre_cliente'] ?? null;
                    $ped_nombre_negocio=$parameter['ped_nombre_negocio'] ?? null;
                    $ped_observaciones=$parameter['ped_observaciones'] ?? null;
                    $ped_direccion_entrega=$parameter['ped_direccion_entrega'] ?? null;
					$ped_telefono_contacto=$parameter['ped_telefono_contacto'] ?? null;
					//$ped_fecha_entrega=$parameter['ped_fecha_entrega'] ?? null;
					//$ped_usr_cliente=$parameter['ped_usr_cliente'] ?? 0;
					$ped_direccion_entrega=$parameter['ped_direccion_entrega'] ?? null;
					$ped_estado=$parameter['ped_estado'] ?? 'A';
                    $ped_descripcion_cancelacion=$parameter['ped_descripcion_cancelacion'] ?? null;
					$ped_fecha_cancelacion=null;//$parameter['ped_fecha_cancelacion'] ?? null;
					
					/*if(
						$ped_fecha_entrega != 'undefined' && 
						$ped_fecha_entrega != 'null' &&
						//$ped_fecha_entrega != undefined && 
						$ped_fecha_entrega != null 
					){
						//date_format(fecha,"%Y-%m-%d");
						$ped_fecha_entrega = $parameter['ped_fecha_entrega'];
						//$ped_fecha_entrega = 'date_format("29/11/1985","%Y-%m-%d")';//$parameter['ped_fecha_entrega'];
					}else{
						$ped_fecha_entrega = NULL;
					}*/
					
					//if($ped_descripcion_cancelacion != 'undefined' && $ped_descripcion_cancelacion != 'null' && $ped_descripcion_cancelacion != ''){$ped_descripcion_cancelacion = $parameter['ped_descripcion_cancelacion'];}else{$ped_descripcion_cancelacion = null;}
                    /*
                    $pro_direccion=$parameter['pro_direccion'] ?? NULL;
                    if($pro_direccion != 'undefined' && $pro_direccion != 'null'){$pro_direccion = $parameter['pro_direccion'];}else{$pro_direccion = NULL;}
                    $pro_telefono=$parameter['pro_telefono'] ?? NULL;
                    if($pro_telefono != 'undefined' && $pro_telefono != 'null'){$pro_telefono = $parameter['pro_telefono'];}else{$pro_telefono = NULL;}
                    $pro_email=$parameter['pro_email'] ?? NULL;
                    if($pro_email != 'undefined' && $pro_email != 'null'){$pro_email = $parameter['pro_email'];}else{$pro_email = NULL;}
                    $pro_nombre_contacto=$parameter['pro_nombre_contacto'] ?? NULL;
                    if($pro_nombre_contacto != 'undefined' && $pro_nombre_contacto != 'null'){$pro_nombre_contacto = $parameter['pro_nombre_contacto'];}else{$pro_nombre_contacto = NULL;}
                    $pro_correo_contacto=$parameter['pro_correo_contacto'] ?? NULL;
                    if($pro_correo_contacto != 'undefined' && $pro_correo_contacto != 'null'){$pro_correo_contacto = $parameter['pro_correo_contacto'];}else{$pro_correo_contacto = NULL;}
                    $pro_telefono_contacto=$parameter['pro_telefono_contacto'] ?? NULL;
                    if($pro_telefono_contacto != 'undefined' && $pro_telefono_contacto != 'null'){$pro_telefono_contacto = $parameter['pro_telefono_contacto'];}else{$pro_telefono_contacto = NULL;}*/
                    

                    $ped_id = $utility->CorrelAutomatico($PDO, "tra_pedidos", "ped_id", "");
                    $ped_no_pedido = $ped_id;//$utility->CorrelAutomatico($PDO, "tra_pedidos", "ped_no_pedido", " and ped_usr_cliente = $ped_usr_cliente");
                    
                    
					/*$existeCorreo = $utility->buscarRegistro($PDO, "tra_proveedores", "pro_correl dato,cli_email", " and UPPER(cli_email)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_email);
                    
                    
                    if($cli_nit == "CF" || $cli_nit == "cf"){
                        $existeNit = 0;
                    }else{
                        $existeNit = $utility->buscarRegistro($PDO, "tra_proveedores", "pro_correl dato,cli_nit", " and UPPER(cli_nit)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_nit);
                    }*/
                    
                    //ped_fecha_entrega,
                    //:ped_fecha_entrega,
                    $sql = "insert into tra_pedidos (
                              ped_id,
                              ped_no_pedido,
                              ped_usr_correl,
                              ped_nombre_cliente,
                              ped_nombre_negocio,
                              ped_observaciones,
                              ped_direccion_entrega,
                              ped_telefono_contacto,
                              ped_usr_cliente,
                              ped_estado,
                              ped_usuarioi,
                              ped_usuariom,
                              ped_fechai,
                              ped_fecham,
                              ped_descripcion_cancelacion,
                              ped_fecha_cancelacion
                            ) values(
                              :ped_id,
                              :ped_no_pedido,
                              :ped_usr_correl,
                              :ped_nombre_cliente,
                              :ped_nombre_negocio,
                              :ped_observaciones,
                              :ped_direccion_entrega,
                              :ped_telefono_contacto,
                              :ped_usr_cliente,
                              :ped_estado,
                              :id_usuario, 
                              :id_usuario, 
                              now(), 
                              now(),
                              :ped_descripcion_cancelacion,
                              :ped_fecha_cancelacion
                            )
                    ";
                    //echo $sql;
					//:ped_fecha_entrega
                    $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'ped_id' => $ped_id,
                        'ped_no_pedido' => $ped_no_pedido,
                        'ped_usr_correl' => $ped_usr_correl,
                        'ped_nombre_cliente' => $ped_nombre_cliente,
                        'ped_nombre_negocio' => $ped_nombre_negocio,
                        'ped_observaciones' => $ped_observaciones,
                        'ped_direccion_entrega' => $ped_direccion_entrega,
                        'ped_telefono_contacto' => $ped_telefono_contacto,
                        //'ped_fecha_entrega' => $ped_fecha_entrega,
                        'ped_usr_cliente' => $id_usuario,
                        'ped_estado' => $ped_estado,
                        'ped_descripcion_cancelacion' => $ped_descripcion_cancelacion,
                        'ped_fecha_cancelacion' => $ped_fecha_cancelacion,
                        'id_usuario' => $id_usuario
                    ]);
                        
                        
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Pedido registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$ped_id,'keyCorrel'=>$ped_no_pedido);//,'query'=>$sql
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'El pedido no pudo ser registrado', 'status'=>403,'token'=>$token,'query'=>$sql);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }

                    if($existeCorreo > 0 || $existeNit > 0){
                        $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(400);
                    }else{
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        
                        
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$cli_correlativo);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser registrado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403,'query'=>$sql);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500,'query'=>$sql);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token,'query'=>$sql);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
	public function insertPedidoDetalle($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();  
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $pro_sucursal = 1;

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'nuevo');

                if($userFuncionality == 'OK'){
                	
                	$pdet_ped_id=$parameter['pdet_ped_id'] ?? 0;
					$pdet_id=$parameter['pdet_id'] ?? 0;
					$pdet_cantidad=$parameter['pdet_cantidad'] ?? 1;
					$pdet_descripcion_producto=$parameter['pdet_descripcion_producto'] ?? null;
                    $pdet_precio_venta=$parameter['pdet_precio_venta'] ?? null;
					$pdet_tipo=$parameter['pdet_tipo'] ?? 0;
					$pdet_padre=$parameter['pdet_padre'] ?? 0;
					$ped_direccion_entrega=$parameter['ped_direccion_entrega'] ?? null;
					$pdet_estado=$parameter['pdet_estado'] ?? 'A';
					

                    $pdet_correl = $utility->CorrelAutomatico($PDO, "tra_pedidos_detalle", "pdet_correl", "");
					/*$existeCorreo = $utility->buscarRegistro($PDO, "tra_proveedores", "pro_correl dato,cli_email", " and UPPER(cli_email)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_email);
                    if($cli_nit == "CF" || $cli_nit == "cf"){
                        $existeNit = 0;
                    }else{
                        $existeNit = $utility->buscarRegistro($PDO, "tra_proveedores", "pro_correl dato,cli_nit", " and UPPER(cli_nit)=UPPER(:valorCampo1) and cli_estado = 'A'",$cli_nit);
                    }*/
                    
                    
                    $sql = "insert into tra_pedidos_detalle (
                              pdet_correl,
                              pdet_ped_id,
                              pdet_id,
                              pdet_descripcion_producto,
                              pdet_cantidad,
                              pdet_precio_venta,
                              pdet_tipo,
                              pdet_padre,
                              pdet_estado,
                              pdet_usuarioi,
                              pdet_usuariom,
                              pdet_fechai,
                              pdet_fecham,
                              pdet_descripcion_cancelacion,
                              pdet_fecha_cancelacion
                            ) values(
                              :pdet_correl,
                              :pdet_ped_id,
                              :pdet_id,
                              :pdet_descripcion_producto,
                              :pdet_cantidad,
                              :pdet_precio_venta,
                              :pdet_tipo,
                              :pdet_padre,
                              :pdet_estado,
                              :id_usuario, 
                              :id_usuario, 
                              now(), 
                              now(),
                              null,
                              null
                            )
                    ";
                    //echo $sql;
					//:ped_fecha_entrega
                    $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'pdet_correl' => $pdet_correl,
                        'pdet_ped_id' => $pdet_ped_id,
                        'pdet_id' => $pdet_id,
                        'pdet_descripcion_producto' => $pdet_descripcion_producto,
                        'pdet_cantidad' => $pdet_cantidad,
                        'pdet_precio_venta' => $pdet_precio_venta,
                        'pdet_tipo' => $pdet_tipo,
                        'pdet_padre' => $pdet_padre,
                        'pdet_estado' => $pdet_estado,
                        //'pdet_descripcion_cancelacion' => $pdet_descripcion_cancelacion,
                        //'pdet_fecha_cancelacion' => $pdet_fecha_cancelacion,
                        'id_usuario' => $id_usuario
                    ]);
                        
                        
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Producto registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$pdet_correl,'query'=>$sql);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'El producto no pudo ser registrado', 'status'=>403,'token'=>$token,'query'=>$sql);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }

                    if($existeCorreo > 0 || $existeNit > 0){
                        $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(400);
                    }else{
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        
                        
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro registrado exitosamente', 'status'=>200,'token'=>$token,'key'=>$cli_correlativo);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser registrado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403,'query'=>$sql);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500,'query'=>$sql);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token,'query'=>$sql);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    public function confirmPedido($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'modificar');
                if($userFuncionality == 'OK'){
                    
                    $ped_id=$parameter['ped_id'] ?? 0;
                    $ped_estado=$parameter['ped_estado'] ?? 'C';

                    $sql = " update tra_pedidos set
                                            ped_estado = :ped_estado,
                                            ped_usuariom = :id_usuario,
											ped_fecham=now() 
											where 1=1 
											and ped_id=:ped_id";

                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'ped_id' => $ped_id,
                        'ped_estado' => $ped_estado,
                        'id_usuario' => $id_usuario
                    ]);
                    
                    
                    if ($result == true) {
                    	$mensaje = "";
                    	if($ped_estado == 'C'){
                    		$mensaje = "'Pedido confirmado exitosamente'";
                    	}else if($ped_estado == 'B'){
                    		$mensaje = "'Pedido Anulado exitosamente'";
						}else{
							$mensaje = "'Pedido Eliminado exitosamente'";
						}
                        $data = array('estado'=>'OK', 'mensaje'=>$mensaje, 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'El pedido no pudo ser confirmado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }    
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){//&& $cli_correlativo <> $existeCorreo
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){//&& $cli_correlativo <> $existeNit
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }
                    if($cli_correlativo == $existeCorreo && $cli_correlativo == $existeNit){//
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }else{
                        if(($existeCorreo > 0 && $cli_correlativo <> $existeCorreo) && ($existeNit > 0 && $cli_correlativo == $existeNit)){//|| $existeNit > 0
                            $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(400);
                        }else{//Registro no existe
                            $stmt = $PDO->prepare($sql);
                            $result = $stmt->execute([
                                'cli_correlativo' => $cli_correlativo,
                                'cli_nombre' => $cli_nombre,
                                'cli_email' => $cli_email,
                                'cli_facturar' => $cli_facturar,
                                'cli_nit' => $cli_nit,
                                'cli_telefono1' => $cli_telefono1,
                                'cli_telefono2' => $cli_telefono2,
                                'cli_direccion' => $cli_direccion,
                                'cli_estado' => $cli_estado,
                                'id_usuario' => $id_usuario
                            ]);
                            if ($result == true) {
                                $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(200);
                            }else{
                                $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(403);
                            }
                        }
                        //$data = array('estado'=>'ERROR', 'mensaje'=>'Registro duplicado', 'status'=>400,'token'=>$token);//'Registro duplicado'
                        //$payload = json_encode($data);
                        //$response->getBody()->write($payload);
                        //$response = $response->withStatus(400);
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
	public function actualizarProducto($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'modificar');
                if($userFuncionality == 'OK'){
                    
                    $pdet_correl=$parameter['pdet_correl'] ?? 0;
                    $pdet_cantidad=$parameter['pdet_cantidad'] ?? 1;

                    $sql = " update tra_pedidos_detalle set
                                            pdet_cantidad = :pdet_cantidad,
                                            pdet_usuariom = :id_usuario,
											pdet_fecham=now() 
											where 1=1 
											and pdet_correl=:pdet_correl";

                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'pdet_correl' => $pdet_correl,
                        'pdet_cantidad' => $pdet_cantidad,
                        'id_usuario' => $id_usuario
                    ]);
                    
                    
                    if ($result == true) {
                    	$mensaje = "Producto Actualizado";
                    	/*if($ped_estado == 'C'){
                    		$mensaje = "'Pedido confirmado exitosamente'";
                    	}else if($ped_estado == 'B'){
                    		$mensaje = "'Pedido Anulado exitosamente'";
						}else{
							$mensaje = "'Pedido Eliminado exitosamente'";
						}*/
                        $data = array('estado'=>'OK', 'mensaje'=>$mensaje, 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'Producto no pudo ser actualizado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }    
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){//&& $cli_correlativo <> $existeCorreo
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){//&& $cli_correlativo <> $existeNit
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }
                    if($cli_correlativo == $existeCorreo && $cli_correlativo == $existeNit){//
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }else{
                        if(($existeCorreo > 0 && $cli_correlativo <> $existeCorreo) && ($existeNit > 0 && $cli_correlativo == $existeNit)){//|| $existeNit > 0
                            $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(400);
                        }else{//Registro no existe
                            $stmt = $PDO->prepare($sql);
                            $result = $stmt->execute([
                                'cli_correlativo' => $cli_correlativo,
                                'cli_nombre' => $cli_nombre,
                                'cli_email' => $cli_email,
                                'cli_facturar' => $cli_facturar,
                                'cli_nit' => $cli_nit,
                                'cli_telefono1' => $cli_telefono1,
                                'cli_telefono2' => $cli_telefono2,
                                'cli_direccion' => $cli_direccion,
                                'cli_estado' => $cli_estado,
                                'id_usuario' => $id_usuario
                            ]);
                            if ($result == true) {
                                $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(200);
                            }else{
                                $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(403);
                            }
                        }
                        //$data = array('estado'=>'ERROR', 'mensaje'=>'Registro duplicado', 'status'=>400,'token'=>$token);//'Registro duplicado'
                        //$payload = json_encode($data);
                        //$response->getBody()->write($payload);
                        //$response = $response->withStatus(400);
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
	public function deleteProducto($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');

                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Cfg_producto', 'modificar');
                if($userFuncionality == 'OK'){
					$pdet_correl=$parameter['pdet_correl'] ?? 0;
                    $pdet_cantidad=$parameter['pdet_cantidad'] ?? 1;
					
                    /*$sql = " update tra_pedidos_detalle set 
                                            pdet_estado = 'E',
                                            pdet_usuariom = :id_usuario,
											pdet_fecham=now() 
											where 1=1 
											and pdet_correl = :pdet_correl";
						//echo $sql;
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'pdet_correl' => $pdet_correl,
                        //'pdet_estado' => $pdet_estado,
                        'id_usuario' => $id_usuario
                    ]);*/

                    $sql = " update tra_pedidos_detalle set
                                            pdet_estado = 'E',
                                            pdet_usuariom = :id_usuario,
											pdet_fecham=now() 
											where 1=1 
											and pdet_correl=:pdet_correl";

                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'pdet_correl' => $pdet_correl,
                        //'pdet_cantidad' => $pdet_cantidad,
                        'id_usuario' => $id_usuario
                    ]);
                    
                    
                    if ($result == true) {
                    	$mensaje = "Producto Eliminado exitosamente";
                        $data = array('estado'=>'OK', 'mensaje'=>$mensaje, 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'El producto no pudo ser eliminado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }    
                    /*$datosRegistrado = "";
                    if($existeCorreo > 0){//&& $cli_correlativo <> $existeCorreo
                        $datosRegistrado .= "Corre: ".$cli_email." ";
                    }
                    if($existeNit > 0){//&& $cli_correlativo <> $existeNit
                        $datosRegistrado .= "Nit: ".$cli_nit;
                    }
                    if($cli_correlativo == $existeCorreo && $cli_correlativo == $existeNit){//
                        $stmt = $PDO->prepare($sql);
                        $result = $stmt->execute([
                        'cli_correlativo' => $cli_correlativo,
                        'cli_nombre' => $cli_nombre,
                        'cli_email' => $cli_email,
                        'cli_facturar' => $cli_facturar,
                        'cli_nit' => $cli_nit,
                        'cli_telefono1' => $cli_telefono1,
                        'cli_telefono2' => $cli_telefono2,
                        'cli_direccion' => $cli_direccion,
                        'cli_estado' => $cli_estado,
                        'id_usuario' => $id_usuario
                        ]);
                        if ($result == true) {
                            $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(200);
                        }else{
                            $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(403);
                        }
                    }else{
                        if(($existeCorreo > 0 && $cli_correlativo <> $existeCorreo) && ($existeNit > 0 && $cli_correlativo == $existeNit)){//|| $existeNit > 0
                            $data = array('estado'=>'ERROR', 'mensaje'=>$datosRegistrado, 'status'=>400,'token'=>$token);//'Registro duplicado'
                            $payload = json_encode($data);
                            $response->getBody()->write($payload);
                            $response = $response->withStatus(400);
                        }else{//Registro no existe
                            $stmt = $PDO->prepare($sql);
                            $result = $stmt->execute([
                                'cli_correlativo' => $cli_correlativo,
                                'cli_nombre' => $cli_nombre,
                                'cli_email' => $cli_email,
                                'cli_facturar' => $cli_facturar,
                                'cli_nit' => $cli_nit,
                                'cli_telefono1' => $cli_telefono1,
                                'cli_telefono2' => $cli_telefono2,
                                'cli_direccion' => $cli_direccion,
                                'cli_estado' => $cli_estado,
                                'id_usuario' => $id_usuario
                            ]);
                            if ($result == true) {
                                $data = array('estado'=>'OK', 'mensaje'=>'Registro actualizado exitosamente'.$cli_correlativo.' '.$existeNit, 'status'=>200,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(200);
                            }else{
                                $data = array('estado'=>'ERROR', 'mensaje'=>'Registro no pudo ser actualizado', 'status'=>403,'token'=>$token);
                                $payload = json_encode($data);
                                $response->getBody()->write($payload);
                                $response = $response->withStatus(403);
                            }
                        }
                        //$data = array('estado'=>'ERROR', 'mensaje'=>'Registro duplicado', 'status'=>400,'token'=>$token);//'Registro duplicado'
                        //$payload = json_encode($data);
                        //$response->getBody()->write($payload);
                        //$response = $response->withStatus(400);
                    }*/
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    public function delete($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                $parameter = $request->getParsedBody();
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_Proveedor', 'eliminar');
                if($userFuncionality == 'OK'){
                    
                    $pro_correl=$parameter['pro_correl'] ?? 0;
                    
                    
                    $sql = " update tra_proveedores set pro_estado = 'E' where pro_correl = :pro_correl";
        
                    $stmt = $PDO->prepare($sql);
                    $result = $stmt->execute([
                        'pro_correl' => $pro_correl
                    ]);
                    if ($result == true) {
                        $data = array('estado'=>'OK', 'mensaje'=>'Proveedor eliminado exitosamente', 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'ERROR', 'mensaje'=>'Proveedor no pudo ser eliminado', 'status'=>403,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                    $response->getBody()->write($payload);
                    $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(500);
        }
        return $response;
    }
    //sin usar
    public function getSign($request, $response, $args) {
        try{
            $dbConnection = new DBConnection();
            $conexion = $dbConnection->setConnection();
            if ($conexion == "OK") {
                $PDO = $dbConnection->getConnection();
                $token = $request->getAttribute('new_token');
                $id_usuario = (int)$request->getAttribute('id');
                $emp_codigo = (int)$request->getAttribute('emp_codigo');
                $amb_codigo = (int)$request->getAttribute('amb_codigo');
                
                $utility = new UtilityDB();
                $userFuncionality = $utility->userFuncionalityAccess($PDO, $id_usuario,$emp_codigo,$amb_codigo, 'Tra_recepcion', 'lectura');
                if($userFuncionality == 'OK'){
                    $parameter = $request->getParsedBody();
                    $att_objeto_codigo = $parameter['att_objeto_codigo'] ?? 0;
                    $att_objeto = $parameter['att_objeto'] ?? 'no_object';
                    
                    $download_dir = DOWNLOAD_DIR_FIRMA;                    

					
                    $sql = "select concat('$download_dir', to_char(att_fechai,'YYYY'),'/',to_char(att_fechai,'MM'),att_archivo) as firma from tra_attachment
                    where 
                    att_objeto_codigo = :att_objeto_codigo and att_objeto = :att_objeto and att_estado = 'A'
                    ";
                    
                    $stmt = $PDO->prepare($sql);
                    $stmt->execute(['att_objeto' => $att_objeto,
                    'att_objeto_codigo' => $att_objeto_codigo
                    ]);
                    $result = $stmt->fetchAll($PDO::FETCH_OBJ);
                    
                    if (!empty($result)) {
                        
                        $path = $result[0]->firma;
                        $type = pathinfo($path, PATHINFO_EXTENSION);
                        $data = file_get_contents($path);
                        $base64 = 'data:image/' . $type . ';base64,' . base64_encode($data);
                        
                        
                        $data = array('estado'=>'OK', 'data'=>$base64, 'status'=>200,'token'=>$token);
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }else{
                        $data = array('estado'=>'NODATA', 'mensaje'=>'No existen datos', 'status'=>200,'token'=>$token,'totalRegistros'=>"0");
                        $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(200);
                    }
                }else{
                    $data = array('estado'=>'ERROR', 'mensaje'=>$userFuncionality, 'status'=>403);
                    $payload = json_encode($data);
                        $response->getBody()->write($payload);
                        $response = $response->withStatus(403);
                }
            
                $PDO = null;
            }else{
                $data = array('estado'=>'ERROR', 'mensaje'=>(string)$conexion,'status'=>500);
                $payload = json_encode($data);
                $response->getBody()->write($payload);
                $response = $response->withStatus(200);
            }
            
        }catch(PDOException $e){
            $data = array('estado'=>'ERROR', 'mensaje'=>$e->getMessage(),'status'=>500,'token'=>$token);
            $payload = json_encode($data);
            $response->getBody()->write($payload);
            $response = $response->withStatus(200);
        }
        return $response;
    }
   
    
}
